/*
 * =====================================================================================
 *
 *       Filename:  Log.cpp
 *
 *    Description:  Definition of polarimter logger.
 *
 *        Version:  0.6.2
 *        Created:  06/28/2010 09:14:58 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physycs, Novosibirsk, Russia
 *
 * =====================================================================================
 */


#include <time.h>
#include <fstream>

#include "Log.h"
#include "PolarimeterConfig.h"
#include <thread>

/*  Define head message manipulator */
std::ostream & log_head_with_time(std::ostream & os)
{
  char time_string[1024];
  time_t t = time(0);
  strftime(time_string,1024,"%F-%T",localtime(&t));
  //os << time_string << ": "<< std::hex << std::this_thread::get_id() << std::dec << ": ";
  os << time_string << ": ";
  //os << time_string << ": ";
  return os;
};

ibn::log LOG(0, nullptr, &log_head_with_time);
