/*
 * =====================================================================================
 *
 *       Filename:  Log.h
 *
 *    Description:  Declare polarimeter logger.
 *
 *        Version:  1.0
 *        Created:  02/08/2008 05:13:33 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physics
 *
 * =====================================================================================
 */
#ifndef IBN_POLARIMETER_LOG_H
#define IBN_POLARIMETER_LOG_H

#include "ibn/log.h"

/*  Logger declaration */
extern   ibn::log LOG;

/* Log levels table */
enum 
{
  QUIET_LOG    = 0, //Suppress all messages accept program crash
  NORMAL_LOG   = 1, //Normal log is needed for operator (default)
	INFO_LOG     = 2, 
  WARNING_LOG  = 3,
  VERBOSE_LOG  = 4, //Verbose log
  VERBOSE2_LOG = 5, //More Verbose log
  VERBOSE3_LOG = 6, //Very verbose log
  DEBUG_LOG    = 7, //Debug log entering into functions
  DEBUG2_LOG   = 8, //More Debug log. Internal function log
  DEBUG3_LOG   = 9, //More Debug log. Cycle log
  HIGH_LOG     =10  //High log level
};

#endif
