#pragma once
namespace phys
{
	const double c = 2.99792458e10; //cm/c exact

  //const double e = 1.602176565e-19; //Coulomb PDG-2012
  const double e = 1.6021766208e-19; //Coulomb PDG-2015

	//const double h = 6.62606876e-27; //erg*c PDG-2000
  const double h = 6.62606957e-27; //erg*c PDG-2012 
	//const double hbar = 1.054571596e-27; //erg*c PDG-2000
  //const double hbar = 1.054571726e-27; //erg*c PDG-2012 
  const double hbar = 1.054571800e-27; //erg*c PDG-2015
  const double hbar_MeV = 6.582119514e-22; //MeV*c PDG-2015



  // ********** ELECTRON MASS *********************
	//const double me  = 0.510999060; //Mev/c^2  PDG-1998
	//const double me  = 0.510998902; //Mev/c^2  PDG-2002
	//const double me  = 0.510998920; //Mev/c^2  PDG-2004
  //const double me  = 0.510998910; //MeV/c^2  PDG-2008 de = 13e-9 MeV/c^2
  //const double   me  = 0.510998928; //MeV/c^2  PDG-2012 de = 11e-9 MeV/c^2
  const double   me  = 0.5109989461; //MeV/c^2  PDG-2015 de = 31e-12 MeV/c^2

	//const double alpha = 1/137.03599976;
	//const double alpha  = 1./137.035999074; //phine structure constant PDG-2012
	const double alpha  = 1./137.035999139; //phine structure constant PDG-2015 +- (31l)
	//const double mue = 1.001159652193;
	const double   mue = 1.001159652187; // PDG-2002;
	//const double muea = 1.159652187e-3;//anomal part of electron magnet momentum
	//const double muea = 1.15965218073e-3;//PDG-2008 error = 0.00000028e-6
  const double muea = 1159.65218076e-6;//PDG-2012 error = 0.00000027e-6

	const double RD = me/muea; 
  // RD old        = 440.64841831751747
  // RD (PDG-2012) = 440.648443109128777
  const double f0 = 818924;
	const double DEDF = RD/f0; //0.000538082094; // MeV/Hz коэффициент, связывающий изменени энергии и изменение частоты = RD/f0

	//struct Value {double val,err;};
	//inline std::istream & operator>>(std::istream &stream, phys::Value &v) { return stream >> v.val >> eat_nodigit() >> v.err; }
	//inline std::ostream & operator<<(std::ostream &stream, phys::Value &v) { return stream << v.val << " " << v.err; }

	namespace polarization
  {
		/*
		inline Value GetEnergy(phys::Value fd, phys::Value vf, double setE=1762)	{
			using math::sq;
			Value en;
			double EnPorog = 1700;
			if(setE>=EnPorog)	{
				en.val =(5. - fd.val/vf.val) * me/muea;
				en.err =(fd.err/vf.val + vf.err*fd.val/sq(vf.val)) * me/muea; 
			}
			if(setE<EnPorog)	{
				en.val = (4.   - 1. + fd.val/vf.val) * me/muea;
				en.err = (fd.err/vf.val + vf.err*fd.val/sq(vf.val)) * me/muea; 
			}
			return en;
		}
		
		inline double GetEnergy(double freq, double vf = 818924, double setE=1762)	{
			phys::Value f = {freq,0};
			phys::Value v = {vf,0};
			return GetEnergy(f,v,setE).val;
		}
		inline	double GetDeltaEnergy(double freq, double vf = 818924)	{
			return me/muea * freq/vf;
		}
		inline double GetFrequency(double energy, double vf = 818924, double setE= 1762)	{
			double EnPorog = 	1700;
			double freq;
			if( setE >= EnPorog)	{
				freq = vf * (5. - energy/me * muea );
			}
			else {
				freq = vf * (energy/me * muea - 3. );
			}
			return freq;
		}
		inline double GetDeltaFrequency(double energy, double vf = 818924, double setE= 1762)	{
			return vf* energy /me * muea;
		}
		*/
		

		//inline data::PhysValue GetEnergy(data::PhysValue fd, data::PhysValue vf, int n , bool isreverse)	
    //{
		//	using math::sq;
		//	data::PhysValue en;
		//	double x =  fabs(fd.value/vf.value) - int( floor(fabs(fd.value/vf.value)) ); //дробная часть частоты деполяризатора
		//	if(isreverse)	{
		//		en.value = (n  - x) * me/muea;
		//	}
		//	else {
		//		en.value = (n - 1 + x) * me/muea;
		//	}
		//	en.error = (fabs(fd.error/vf.value) + fabs(vf.error*fd.value/sq(vf.value)) ) * me/muea; 
		//	return en;
		//}

		//inline double GetEnergy(double freq, double vf, int n,bool isreverse )
    //{
		//	data::PhysValue f = data::PhysValue(freq,0);
		//	data::PhysValue v = data::PhysValue(vf,0);
		//	return GetEnergy(f,v,n,isreverse).value;
		//}

		//inline	double GetDeltaEnergy(double freq, double vf)
    //{
		//	return me/muea * freq/vf;
		//}

		//inline double GetFrequency(double energy, double vf, int n, bool isreverse, int dep_fr_num=0)
    //{
		//	double freq;
		//	if(isreverse)
    //  {
		//		freq =   vf * (n - energy/me * muea + dep_fr_num );
		//	}
		//	else {
		//		freq = vf * (energy/me * muea - n + 1 + dep_fr_num );
		//	}
		//	return freq;
		//}

		//inline double GetDeltaFrequency(double energy, double vf)
    //{
		//	return vf* energy /me * muea;
		//}
	};
}
