#ifndef IBN_CONCURRENCE_H
#define IBN_CONCURRENCE_H

#include "Module.h"
#include "ModuleInventory.h"

#include <list>

namespace camac
{
  //Astract class providing interface for concurrence schime
  class Concur :  virtual public ModuleInventory  
  {
    public:
      enum {
        CH0 = 0,
        CH1 = 0x01,
        CH2 = 0x02,
        CH3 = 0x04,
        CH4 = 0x08,
        CH5 = 0x10,
        CH6 = 0x20,
        CH7 = 0x40,
        CH8 = 0x80,
      };
      virtual ~Concur(void){}
      virtual void SetMask(unsigned) = 0;
      virtual unsigned GetMask(void) const = 0;
  };

  class Concur_L0313 : public Module, public Concur, virtual public ModuleInventory
  {
    //маска для двухкратных совпадений на 1-2 канале
    static const unsigned int mask12 = 0x3;
    public:
    //	Concur_L0313(void): ModuleInventory("unknown", "Concurence", "L0313"){}
    Concur_L0313(std::string nm, camac::Address addr, unsigned int mask = CH0) :
      ModuleInventory(nm, "Concurence", "L0313"),									
      Module(addr)
    {
      SetMask(mask);
    }

    Concur_L0313(std::string nm): ModuleInventory(nm, "Concurence", "L0313"){}

    ~Concur_L0313(void){};

    void SetMask(unsigned mask)
    {
      if(mask>15) throw std::out_of_range(std::string(GetType()) + ": Bad Mask");
      std::cerr << "test" << std::endl;
      for(int i = 0; i<=40 ; i++)
      {
        try
        {	
          AF(GetChannel(),i,&mask);	
        }
        catch(Error & e)
        { 
          std::cerr <<  " F = " << i << " A = " << GetChannel() << " " << e.what() << std::endl;
        }
      }
      std::cerr << "test" << std::endl;
    }

    void SetMask(bool ch0, bool ch1, bool ch2, bool ch3)
    {
      unsigned int mask = ch0 + ch1*2 + ch2*4 + ch3*8;
      SetMask(mask);
    }

    unsigned GetMask(void)  const
    {
      u32_t  mask;
      AF(GetChannel(),1,&mask);
      return mask;
    }
  };




  class Concur_L0306  : public Concur, public Module, virtual public ModuleInventory
  {
    public:
      Concur_L0306(std::string nm="unknown"): 
        ModuleInventory(nm, "Concurence", "L0306")
      {
      }

      Concur_L0306(std::string nm, Address & adr, unsigned mask = CH0) : 
        ModuleInventory(nm, "Concurence", "L0306"), Module(adr)
      {
        SetMask(mask);
      }

      Concur_L0306(std::string nm, Address & adr, std::list<unsigned> chan_list) : 
        ModuleInventory(nm, "Concurence", "L0306"), Module(adr)
      {
				SetMask(chan_list);
      }


      ~Concur_L0306(void){}

      void Bind(Address &adr, unsigned mask)
      {
        Module::Bind(adr);
        SetMask(mask);
      }

      void Bind(Address &adr, std::list<unsigned> chan_list)
      {
        Module::Bind(adr);
        SetMask(chan_list);
      }

			void SetMask(std::list<unsigned> chan_list)
			{
				unsigned mask=0;
				for(auto c : chan_list) mask |= ( 0x1 << c ); 
        SetMask(mask);
			}

      void SetMask(unsigned mask)
      {
        u16_t data;
        data = mask;
        AF(GetChannel(),WRITE,&data);
      }

      unsigned GetMask(void) const
      {
        u16_t data;
        AF(GetChannel(), READ,&data);
        //return unsigned( (data >> shift) & 0xff);
        return unsigned(data);
      }
    private:
      enum { READ = 1, WRITE = 17};
  };
}
#endif //IBN_CONCURRENCE_H
