#ifndef IBN_TDISKR_H
#define IBN_TDISKR_H

#include "Module.h"
#include "ModuleInventory.h"

namespace camac 
{

	class Diskriminator : protected Module, virtual public ModuleInventory
	{
		static const unsigned int Step = 5;
		static const unsigned int Min = 5;
		static const unsigned int Max = 1285;

		public:
		Diskriminator(void){}

		Diskriminator(const camac::Address adr) : Module(adr){}


		virtual ~Diskriminator(void){}

		unsigned int read(const int channel) const 
		{
			//			u16_t data;
			u32_t data;
			AF(channel,1, &data);
			return (unsigned int)(Step*data+Min);
		}

		void write(const int channel, unsigned int level) 
		{
			if( level > Max && level < Min ) throw std::out_of_range(std::string(GetType()) + ": Bad threshold");
			u16_t data = (u16_t)( (level - Min) / Step );
			AF(channel,17, &data);
		}
	}; //end of class Diskr_base

	class DiskrD0302 : protected Diskriminator, virtual public ModuleInventory 
	{
		public:
			DiskrD0302(std::string nm) : ModuleInventory(nm, "Diskriminator", "D0302"){}
			DiskrD0302(std::string nm/*bockname*/, const camac::Address adr, unsigned int threshold=10) :
				ModuleInventory(nm, "Diskriminator", "D0302"),
				Diskriminator(adr)
		{
			SetThreshold(threshold);
		}

			virtual ~DiskrD0302(void){}

			unsigned int GetThreshold(void) const 
			{
				return Diskriminator::read(GetChannel());
			}

			void SetThreshold(unsigned int threshold) 
			{
				Diskriminator::write(GetChannel(),threshold);
			}

			void Bind(const Address &adr)   { Module::Bind(adr);}
			void Bind(const Address &adr,unsigned th )   { Module::Bind(adr); SetThreshold(th);}

	};
}

#endif // IBN_TDISKR_H
