//#=====================================================================================
//#       Class:  Multiform
//#
//# Description:  For module, wich formirates M impulses after N 
//# 							base signals (RF in our case)
//#
//#      Author:  Ivan B. Nikolaev
//#     Created:  09.01.2003
//#    Revision:  1.1
//#=====================================================================================
#ifndef IBN_CAMAC_MULTIFORM_H
#define IBN_CAMAC_MULTIFORM_H
namespace camac	{
	class Multiform : public Module	{
		static const unsigned MAX_IMPULSES = 1024;
		public:
			Multiform(void)	{}
			Multiform(Address &a) : Module("Multiform",a) {}
			~Multiform(void)	{};
			/* N -- amount of permited impulses */
			/* M -- amount of allowed impulses */
			/* set M number */
			void SetLength(unsigned length)	{
				AF(1,16,&length);
			}
			/* read M number */
			unsigned GetLength(void)	{
				u32_t length;
				AF(1,0,&length);
				return length;
			}
			/* set N number */
			void SetDelay(unsigned delay)	{
				AF(0,16,&delay)
			}
			/* get N number */
			unsigned GetDelay(void)	{
				u32_t delay;
				AF(0,0,&delay);
				return delay;
			}
	};
}
#endif //IBN_CAMAC_MULTIFORM_H
