#ifndef SMV_ZCP_H
#define SMV_ZCP_H

#include "Module.h"
#include "ModuleInventory.h"

namespace camac {

    class Zcp_base : public Module, virtual public ModuleInventory {

	public:
	    Zcp_base(void){}

	    Zcp_base(const camac::Address adr) : Module(adr){}


	    ~Zcp_base(void){}

	    unsigned int read(const int channel) const 
	    {
		u16_t data;
		AF(channel,2, &data);
		return (unsigned int)(data);
	    }

	    inline void LLam(void) 
	    {
		while (!IsLam()) {/*cout << " \n"; usleep(1000000);*/ }
	    }
	    void Sbros_LAM(void)
	    {
		AF(0,10);
	    }    

	    inline void WaitLam()
	    {
		//wait lam forever
		Module::WaitLam(-1);
	    }



    }; //end of class Zcp_base

    class Zcp : public Zcp_base, virtual public ModuleInventory {
	public:
	    Zcp(const char* nm="unknown"):ModuleInventory(nm, "Zcp", "any") {}

	    Zcp(const char* nm, const camac::Address adr) :
		ModuleInventory(nm, "Zcp", "any"),
		Zcp_base(adr)
	{
	}

	    ~Zcp(void){}

	    unsigned int GetData(void)  
	    {
		return Zcp_base::read(GetChannel());
	    }



	    inline void WaitLam()  
	    { 
		Zcp_base::WaitLam();
	    }

	    void Bind(Address adr) 	
	    {
		Module::Bind(adr);
	    }



	    inline void Sbros(void) {Zcp_base::Sbros_LAM();}

    };//end of class Zcp
}

#endif // SMV_ZCP_H
