/*
 * =====================================================================================
 *
 *       Filename:  ArraySerializaton.cpp
 *
 *    Description:  Implementation of Array Serialization
 *
 *        Version:  1.0
 *        Created:  07/13/2010 02:45:15 AM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physycs, Novosibirsk, Russia
 *
 * =====================================================================================
 */

#include "ArraySerializaton.h"

namespace std
{
  void eat(std::istream &is)
  {
    char c;
    do
    { 
      is.get(c);
      if(c=='n')
      {
        is.get(c);
        if(c=='a')
        {
          is.get(c);
          if(c=='n')
          {
            c='0';
          }
        }
      }
    } while(!isdigit(c) && is);
    is.putback(c);
  }

  std::istream & operator>>(std::istream & is, ibn::valer<data::Array::Value_t>  & v)
  {
    is>>v.value;
    eat(is);
    is>>v.error;
    return is;
  }

  std::istream & operator>>(std::istream & is, ibn::valer<data::Array::Value_t>::reference  v)
  {
    is>>v.value;
    eat(is);
    is>>v.error;
    return is;
  }

  std::istringstream & operator>>(std::istringstream & is, ibn::valer<data::Array::Value_t>::reference  v)
  {
    is>>v.value;
    eat(is);
    is>>v.error;
    return is;
  }

  std::istringstream & operator>>(std::istringstream & is, ibn::valer<data::Array::Value_t> & v)
  {
    is>>v.value;
    eat(is);
    is>>v.error;
    return is;
  }

  std::ostream & operator<<(std::ostream & os, const ibn::valer<data::Array::Value_t> & v)
  {
    std::ostringstream ostr;
    ostr.precision(os.precision());
    ostr.setf(os.flags());
    ostr<<v.value<<"+-";
    ostr.unsetf(std::ios_base::showpos);
    ostr<<v.error;
    os<<ostr.str();
    return os;
  }

  std::ostream & operator<<(std::ostream & os, const ibn::valer<data::Array::Value_t>::const_reference & v)
  {
    std::ostringstream ostr;
    ostr.precision(os.precision());
    ostr.setf(os.flags());
    ostr<<v.value<<"+-";
    ostr.unsetf(std::ios_base::showpos);
    ostr<<v.error;
    os<<ostr.str();
    return os;
  }
} //end of namespace std

