#pragma once
/*
 * =====================================================================================
 *
 *       Filename:  polarimeter.cpp
 *
 *    Description:  This class keep the status of polarimeter.  
 *                  Counters load,  deta,  current frequency etc...
 *        Version:  0.7.1
 *        Created:  06/27/2010 06:06:36 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physics, Novosibirsk, Russia
 *
 * =====================================================================================
 */

#include <vector>
#include <string>

#include "Storage.h"

namespace data
{
  class BunchInfo_t
  {
    public:

      BunchInfo_t(unsigned numcounter)
      {
        counter.resize(numcounter);
        cncr.resize(numcounter/2);
        VviCounterStatus.resize(numcounter);
      }

      ~BunchInfo_t(void){}

      std::vector<double> counter;
      std::vector<double> cncr;
      std::vector<int> VviCounterStatus; // 0 - OFF, 1 - ON, 2 - overload OFF, overload ON

      double I=0;
      double delta=0;
      double delta_cncr=0;
      double counter_sum=0;
      double cncr_sum=0;
  };

  class Status  : public Storage
  {
    public:

      Status(void){}
      ~Status(void){}
      void Save(std::string){}
      void Load(std::string){}

      bool ismeasure=false,isscan=false; 
      std::vector< BunchInfo_t > BunchInfo; 
      double frequency=0,energy=0;
      double measured_frequency=0;
      double time=0,remain_time=0;
      size_t N=0;
  };
}
