/*
 * =====================================================================================
 *
 *       Filename:  debug.h
 *
 *    Description:  class for debug printing
 *
 *        Version:  1.0
 *        Created:  03/14/2008 01:12:10 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physics
 *
 * =====================================================================================
 */


#ifndef  IBN_DEBUG_H_INC
#define  IBN_DEBUG_H_INC

#include <iostream>
#include <string>

namespace ibn 
{
  class debug 
  {
    public:
      debug(std::string t) 
      {
        title = t;
        index=0;
      }

      ~debug(void) {}

      void print(std::string s="")    
      {
        std::clog << title << ": " << index++ <<  ": " << s << std::endl;
      }

    private:
      std::string title;
      unsigned index;
  };
}


#endif   /* ----- #ifndef IBN_DEBUG_H_INC  ----- */

