/*
 * =====================================================================================
 *
 *       Filename:  FitParConfiguration.h
 *
 *    Description:     .
 *
 *        Version:  1.0
 *        Created:  14.11.2012 11:10:07
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physycs, Novosibirsk, Russia
 *
 * =====================================================================================
 */
#ifndef IBN_POLARIMETER_FIT_FITPAR_CONFIGURATION_H
#define IBN_POLARIMETER_FIT_FITPAR_CONFIGURATION_H
namespace fit
{
  struct FitParConfiguration
  {
    std::string name; // name of the parameter
    double initial; //initial value of fit paraimeter
    double step; //variable step;
    double minimum; //minimum allowed bound
    double maximum; //maximum allowed bound
    bool fixed; // is parameter fixed or not
    bool limit; //is limit
    FitParConfiguration(void) :
      name(""),initial(0), step(1), minimum(0), maximum(0), fixed(false), limit(false) {}
    FitParConfiguration( std::string n, double ini, double s=1, double min=0, double max=0, bool fix=false, bool lim=false) :
      name(n), initial(ini), step(s), minimum(min), maximum(max), fixed(fix), limit(lim) 
    {}
  };
}
#endif
