#ifndef IBN_SIMPLE_ATAN_FITTER_H
#define IBN_SIMPLE_ATAN_FITTER_H

#include "data/Array.h"
//#include "FitParConfiguration.h"
#include "Log.h"

//#include "TFitterMinuit.h"
#include "Fitter.h"
#include "Minuit2/MnPrint.h"
#include "gui/EnergyCalibrationView.h"
#include "data/EnergyCalibrationStorage.h"

#include <TF1.h>
namespace fit
{
    class SimpleAtanFitter : public Fitter
    {
      std::unique_ptr<TF1> root_function;
      public:
      data::Array * TIME;
      data::Array * DELTA;
      data::Array fit_result;
//      TFitterMinuit * minuit=nullptr;
      std::unique_ptr<ROOT::Minuit2::MnApplication> minimizer;

      mutable double TD; //depolarization moment
      mutable double D; //jump
      mutable double TAU; //depolarization time
      mutable double C;   //initial level
      mutable double K1;  //slope before depolarization
      mutable double K2;  //slope after depolarization
      mutable double TC;   //count time (not free parameter)

      SimpleAtanFitter(void);
      ~SimpleAtanFitter(void);
      void Fit(void);
      void SetParameters(const std::vector<double> & par) const;
      static double heaviside(double x);
      static double int1_heaviside(double x);
      static double int2_heaviside(double x);
      double delta(double t) const ;
      double delta_average(double t, double T) const ;
      static double delta_average(double *X, double *P);
      double operator() (const std::vector<double> & par) const;
      double Up() const;
      void SetMinPar(void);
      void DrawFunction(void);
      /*  Ищет скачок, предполагая, что время обозначено параметром T */
      ROOT::Minuit2::MnUserParameters FindJump(void);
    };
}
#endif
