#ifndef IBN_GUI_DATA_NOSLOPE_H
#define IBN_GUI_DATA_NOSLOPE_H
#include <memory>
#include <algorithm>
#include "Data.h"
#include "../fit/AntiSlopeFitter.h"
namespace gui
{
  class AntiSlopeData : public Data
  {
    data::Array * DATA;
    data::Array * TIME;
    std::shared_ptr<fit::AntiSlopeFitter> fitter;
    public:

      AntiSlopeData(data::Array * sd, data::Array * tm, std::string nm="", std::string at="")
        : Data(nm,nm,at)
      {
        DATA = sd;
        TIME = tm;
        fitter.reset(new fit::AntiSlopeFitter(DATA,TIME));
        data = new data::Array;
        Update();
      }

      ~AntiSlopeData(void)
      {
        delete data;
      }

      void Update(void)
      {
        size_t size = std::min(DATA->size(), TIME->size());
        if(data->size()>=size) return;
        fitter->Fit();
        data->resize(size);
        show.resize(size);
        for(unsigned i=0;i<size; i++)
        {
          double norm = fitter->fitfun((*TIME)[i].value);
          (*data)[i].value =  ((*DATA)[i].value)/norm;
          (*data)[i].error =  ((*DATA)[i].error)/norm;
          show[i]=1;
        }
      }
  };//class DataNoSlope
} //namespace gui
#endif
