#pragma once
#include <vector>
#include <string>

#include <TGWindow.h>
#include <TGFrame.h>
#include <TGLabel.h>
#include <TGNumberEntry.h>
#include "data/Calculator.h"

namespace gui
{
  class CalculatorConfigDialog : public TGTransientFrame
  {
    public:
      CalculatorConfigDialog(const TGWindow *w, data::Calculator *);
      ~CalculatorConfigDialog(void);
      void GetData(data::Calculator *);
      void SetData(const data::Calculator * );
      Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);
    private:
      TGHorizontalFrame * bf;
      std::vector<std::string> b_name;
      std::vector<TGTextButton*> b;
      TGLayoutHints *bl;

      TGLayoutHints *ll,*lr;
      TGNumberEntry *alpha, *N;
      TGLabel *alpha_lbl, *N_lbl;
      TGHorizontalFrame *alpha_f, *N_f;
      data::Calculator * calculator;
  };
}
