// =====================================================================================
//
//       Filename:  CanvasDialog.h
//
//    Description:  Embeded Canvas
//
//        Version:  1.0
//        Created:  25.12.2014 18:47:05
//       Revision:  none
//       Compiler:  g++
//
//         Author:  Ivan B. Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
//   Organization:  Budker Institute of Nuclear Physics
//
// =====================================================================================

#ifndef  IBN_POL_GUI_CANVAS_DIALOG_H
#define  IBN_POL_GUI_CANVAS_DIALOG_H
#include <memory>

#include <TGFrame.h>
#include <TGLabel.h>
#include <TGButton.h>
#include <TGMenu.h>
#include <TGTextEntry.h>
#include <TGNumberEntry.h>
#include <TRootEmbeddedCanvas.h>

#include "measurement/EnergyCalibrationConfig.h"
#include "LabeledNumberEntry.h"


namespace gui
{

	class CanvasDialog : public TGTransientFrame
	{
		public:
			CanvasDialog(const TGWindow * w);
			~CanvasDialog(void);
			Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
		private:
			TGLayoutHints * nel;
			//std::unique_ptr<TGMenuBar>;
			std::unique_ptr<TRootEmbeddedCanvas> fCanvas;
			std::unique_ptr<TGLayoutHints> fCanvasLayout;
			std::unique_ptr<TGHorizontalFrame> fButtonFrame;
	};
}
#endif   // ----- #ifndef CanvasDialog_INC  ----- 
