#include"ConcurConfigDialog.h"
#include"Utils.h"
#include<TGLabel.h>
namespace   gui {

    enum {B_OK,  B_CANCEL};
    enum {TE_DELAY};




    ConcurConfigDialog::ConcurConfigDialog(measurement::EnergyCalibration * pol, const TGWindow *p, const TGWindow *main,
            UInt_t w, UInt_t h, UInt_t options) :
        TGTransientFrame(p,main,w,h,options | kFixedWidth)
	{
            EC=pol;
            CheckFrame = new TGHorizontalFrame(this,20,20,kFixedWidth);
            ButtonFrame = new TGHorizontalFrame(this,20,20,kFixedWidth);

            Outside = new TGGroupFrame(this, new TGString("Outside"));
            Inside  = new TGGroupFrame(this, new TGString("Inside"));
            CheckLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft,5, 5, 5, 5);
            ButtonFrameLayout = new TGLayoutHints (kLHintsTop | kLHintsLeft| kLHintsExpandX,5,5,0,5);
            ButtonLayout = new TGLayoutHints (kLHintsTop | kLHintsCenterX | kLHintsExpandX,4,4,4,4);

            In2  = new TGCheckButton(Inside, new TGHotString("Counter 4"), -1);
            In1  = new TGCheckButton(Inside, new TGHotString("Counter 3"), -1);

            Out2 = new TGCheckButton(Outside, new TGHotString("Counter 2"), -1);
            Out1 = new TGCheckButton(Outside, new TGHotString("Counter 1"), -1);

            bool  in1=false,in2=false,out1=false,out2=false;
            //POL->GetConcurrenceConfiguration(out1,out2,in1,in2);


            Out1->SetState(EButtonState(out1));
            Out2->SetState(EButtonState(out2));
            In1->SetState(EButtonState(in1));
            In2->SetState(EButtonState(in2));

            Inside->AddFrame(In2,CheckLayout);
            Inside->AddFrame(In1,CheckLayout);

            Outside->AddFrame(Out2,CheckLayout);
            Outside->AddFrame(Out1,CheckLayout);

            TELayout = new TGLayoutHints (kLHintsTop | kLHintsLeft,40,40,0,0);
            TEFrame = new TGHorizontalFrame(this,20,20,kFixedWidth);
            //DelayTE = new TGTextEntry(TEFrame,setString(EC->GetRandomDelay()).c_str(),TE_DELAY);
            DelayTE = new TGTextEntry(TEFrame,setString(0).c_str(),TE_DELAY);
            unsigned text_entry_size = 80;
            DelayTE->Associate(this);
            DelayTE->SetMaxLength(8);
            DelayTE->Resize(text_entry_size,DelayTE->GetDefaultHeight());
            DelayTE->SetFont("-adobe-courier-bold-r-*-*-14-*-*-*-*-*-iso8859-1");

            OkButton = new TGTextButton(ButtonFrame, "&Ok", B_OK);
            CancelButton = new TGTextButton(ButtonFrame, "&Cancel", B_CANCEL);
            OkButton->Associate(this);
            CancelButton->Associate(this);
            ButtonFrame->AddFrame(OkButton,ButtonLayout);
            ButtonFrame->AddFrame(CancelButton,ButtonLayout);

            CheckFrame->AddFrame(Outside,CheckLayout);
            CheckFrame->AddFrame(Inside,CheckLayout);

            AddFrame(CheckFrame,CheckLayout);
            TEFrame->AddFrame(new TGLabel(TEFrame, new TGHotString("Delay:")),TELayout);
            TEFrame->AddFrame(DelayTE,TELayout);
            AddFrame(TEFrame,ButtonFrameLayout);
            //ButtonFrame->Resize(200,20);
            Resize(258,172);
            AddFrame(ButtonFrame,ButtonFrameLayout);
            Layout();
            SetWindowName("Cocncurrence configuration");
            MapSubwindows();
            MapWindow();
            //fClient->WaitFor(this);
        }



    Bool_t ConcurConfigDialog::ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2)	{
        switch( GET_MSG(msg) )	{
            case kC_COMMAND:
                switch (GET_SUBMSG(msg)) {
                    case kCM_BUTTON:
                        switch(parm1)  {
                            case B_OK:
                                //EC->SetConcurrenceConfiguration( 
                                //        Out1->GetState(),
                                //        Out2->GetState(),
                                //        In1->GetState(),
                                //        In2->GetState()
                                //        );
																//break;
                            case B_CANCEL:	
                                CloseWindow();
                                break;
                            default: 
                                break;
                        }
                        break; //end of switch param 1
                } //end of GET_SUBMSG(msg)
                break; //end of kC_COMMAND

            case kC_TEXTENTRY:
                switch(GET_SUBMSG(msg)){
                    case kTE_ENTER:
                        switch(parm1){
                            case TE_DELAY:	{
                                                    long unsigned data;	
                                                    getData(DelayTE->GetText(),data);
//                                                    EC->SetRandomDelay(data);
//                                                    std::cout << "# Set delay " << EC->GetRandomDelay() << std::endl;
                                                }
                                                break;
                        }// end of swirch param1
                        break; // end of kTE_ENTER 
                } //GET_SUBMSG
                break; //end of kC_TEXTENTRY
        }//end of GET_MSG(msg)
        return kTRUE;
    }
}//end of namespace gui
