#ifndef IBN_GUI_CONCUR_CONFIG_DIALOG_H
#define IBN_GUI_CONCUR_CONFIG_DIALOG_H

#include<TGFrame.h>
#include<TGButton.h>
#include<TGTextEntry.h>

#include "measurement/EnergyCalibration.h"
namespace   gui
{
	class ConcurConfigDialog : public TGTransientFrame
	{
		TGHorizontalFrame *CheckFrame;
		TGHorizontalFrame *ButtonFrame;
		TGHorizontalFrame *TEFrame;
		TGGroupFrame 	  *Inside, *Outside;
		TGTextButton   *OkButton, *CancelButton;
		TGCheckButton  *In1, *In2, *Out1, *Out2;
		TGLayoutHints * CheckLayout;
		TGLayoutHints *ButtonFrameLayout;
		TGLayoutHints *ButtonLayout;
		TGLayoutHints *TELayout;
		TGTextEntry * DelayTE;
		measurement::EnergyCalibration * EC;
		public:
		ConcurConfigDialog(measurement::EnergyCalibration * ec, const TGWindow *p, const TGWindow *main,
				UInt_t w, UInt_t h, UInt_t options ) ;

		virtual ~ConcurConfigDialog(void)
		{
			delete Out1;
			delete Out2;
			delete In1;
			delete In2;
			delete ButtonLayout;
			delete OkButton;
			delete CancelButton;
			delete Inside;
			delete Outside;
			delete DelayTE;
			delete  CheckLayout;
			delete  ButtonFrameLayout;
			delete CheckFrame;
			delete ButtonFrame;
			delete TEFrame;
		}

		virtual void CloseWindow(void){	delete this;}

		virtual Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);
	};
}
#endif //IBN_GUI_CONCUR_CONFIG_DIALOG_H


