// =====================================================================================
//
//       Filename:  CounterConfigDialog.h
//
//    Description:  Manipulate high voltage of the counters
//
//        Version:  1.0
//        Created:  07.07.2014 16:40:45
//       Revision:  none
//       Compiler:  g++
//
//         Author:  Ivan B. Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
//   Organization:  Budker Institute of Nuclear Physics
//
// =====================================================================================
#ifndef IBN_POLARIMETER_GUI_COUNTER_CONFIG_DIALOG_H
#define IBN_POLARIMETER_GUI_COUNTER_CONFIG_DIALOG_H
#include <memory>
#include <vector>

#include <TGButton.h>
#include <TGNumberEntry.h>
#include <TGLabel.h>
#include <TGFrame.h>

namespace camac
{
	class EnergyCalibrationCamac;
}

namespace gui
{
	class CounterConfig;

	class CounterConfigDialog : public TGTransientFrame
	{
		public:
			CounterConfigDialog(const TGWindow * w, camac::EnergyCalibrationCamac * c);
			~CounterConfigDialog(void);
			Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
			void Update(void);
		private:
			std::vector<CounterConfig*>   fCounterConfig;
			std::unique_ptr<TGTextButton> fUpdateButton;
			std::unique_ptr<TGTextButton> fOnAllButton;
			std::unique_ptr<TGTextButton> fOffAllButton;
			std::unique_ptr<TGTextButton> fResetAllButton;
			std::unique_ptr<TGLayoutHints> fLayout;
			std::unique_ptr<TGLayoutHints> fButtonLayout;
			std::unique_ptr<TGHorizontalFrame> fButtonFrame;
			camac::EnergyCalibrationCamac * camac;
	};
}
#endif
