/*
 * =====================================================================================
 *
 *       Filename:  Data.cpp
 *
 *    Description:  Gui data
 *
 *        Version:  1.0
 *        Created:  07/12/2010 03:40:37 AM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physycs, Novosibirsk, Russia
 *
 * =====================================================================================
 */
#include "Log.h"

#include "Data.h"

namespace gui
{
	Data::Data(void):
		data(0),name(""),title(""),axis_title("")
	{
	}

	Data::Data(std::string nm, std::string tl, std::string at):
		data(0), name(nm),title(tl==""?nm:tl),axis_title(at=""?title:at)
		{
		}

	Data::Data(data::Array * dt, std::string nm, std::string tl, std::string at):
		data(dt), name(nm), title(tl==""?nm:tl), axis_title(at=""?title:at)
		{
		}

	Data::Data(data::Array & dt, std::string nm, std::string at,  int b,  int c,  int p):
		data(&dt), name(nm),  title(nm), axis_title(at)
	{
		bunch=b;
		counter=c;
		pair = p;
	}

	//Data::Data(const Data &d):
	//	data(d.data), name(d.name), title(d.title), axis_title(d.title)
	//{
	//}

	//Data & Data::operator=(const Data & d)
	//{
	//	data=d.data;
	//	name=d.name;
	//	title=d.title;
	//	axis_title=d.axis_title;
	//	return *this;
	//}

	void Data::SetAxisTitle(std::string s) 
	{
		axis_title = s;
	}
	data::Array & Data::operator()(void)
	{
		return *data;
	}

	std::vector<double> & Data::value(void)
	{
		return data->vvalue();
	}

	std::vector<double> & Data::error(void)
	{
		return data->verror();
	}

	double *Data::v(void)
	{
		return &(*data)[0].value;
	}

	double *Data::e(void)
	{
		return &(*data)[0].error;
	}


	ibn::valer<data::Array::Value_t>::reference  Data::operator[](unsigned i)
	{
		return (*data)[i];
	}

	ibn::valer<data::Array::Value_t>::const_reference Data::operator[](unsigned i) const
	{
		return (*data)[i];
	}

	size_t Data::size(void) const {return data->size();}
}
