#ifndef IBN_GUI_DATAVIEW_DIALOG_H
#define IBN_GUI_DATAVIEW_DIALOG_H

#include <map>
#include <string>
#include <memory>

#include <TGFrame.h>
#include <TGTab.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TGComboBox.h>
#include <TGLabel.h>

#include "ibn/regexp.h"

#include "EnergyCalibrationView.h"

namespace gui 
{

  class DataViewDialog	: public TGTransientFrame   
  {
    EnergyCalibrationView * ECV;
    struct CheckButton_t 
    {
      int id;
      TGCheckButton * button;
    };
    static const int show_shift=1024;
    typedef std::map < std::string, CheckButton_t  > CBList_t;
    CBList_t CBList;

    struct CheckButton2_t
    {
      int * flag;
      TGCheckButton * button;
    };
    typedef std::map < unsigned, CheckButton2_t > CBFlag_t;
    CBFlag_t CBFlag;

    std::map < unsigned , std::string > IdGraphMap;
    std::unique_ptr<TGLayoutHints> lt; /*  layout of elementes */
    std::unique_ptr<TGGroupFrame> GFBunch; /* frame with chekbuttons */

    std::unique_ptr <TGHorizontalFrame> btn_f; /* Frame with buttons */
    std::unique_ptr < TGTextButton> RareButton; /* Button to rare graphs note. */

    std::unique_ptr <TGTab> tab;

    std::map<int, Data*> combo_map;
    std::unique_ptr < TGHorizontalFrame> create_f;
    std::unique_ptr <TGComboBox> xdata_combo; /*  combo box with data for x */
    std::unique_ptr <TGComboBox> ydata_combo; /*  combo box with data for y */
    std::unique_ptr <TGTextButton> create_tb; /*  Create graph */

    int skip_bad_point_cb_id;
    std::unique_ptr <TGCheckButton> skip_bad_point_cb; /*  skip bad point */
    int draw_notes_cb_id;
    std::unique_ptr <TGCheckButton> draw_notes_cb; /* draw note  */

    enum 
    {
      TB_OK,
      TB_APPLY,
      TB_CANCEL,
      TB_RESET,
      TB_RARE,
      TB_CREATE,
      COMBO_XDATA,
      COMBO_YDATA
    };

    bool lockWindow;

    public:

    DataViewDialog(const TGWindow * main, EnergyCalibrationView *ecv);

    ~DataViewDialog(void);

    void FillCheckButtons(void);

    void UpdateView(void);

    void AdvancedDraw(void);

    void CloseWindow(void);

    Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);
  };
}
#endif
