#ifndef DELAY_LINE_DIALOG_H
#define DELAY_LINE_DIALOG_H
/*
 * =====================================================================================
 *
 *       Filename:  DelayLineConfig.h
 *
 *    Description:  Window for delay line configuration.
 *
 *        Version:  1.0
 *        Created:  09/23/2008 04:03:27 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physics
 *
 * =====================================================================================
 */

#include <vector>
#include <memory>

//#include <boost/shared_ptr.hpp>

#include <TGFrame.h>
#include <TGNumberEntry.h>
#include <TGLabel.h>
#include <TGButton.h>


#include "measurement/EnergyCalibrationCamac.h"
#include "measurement/EnergyCalibration.h"

namespace gui 
{

  class DelayLineDialog  : public TGTransientFrame 
  {
    std::unique_ptr<TGHorizontalFrame> button_frame_ptr;
    std::unique_ptr<TGGroupFrame> entry_frame_ptr;
    std::unique_ptr<TGButton> apply_button_ptr, ok_button_ptr;
    std::vector< std::vector<TGNumberEntry*> > number_entry;
    camac::EnergyCalibrationCamac * camac;
    measurement::EnergyCalibration * EC;
		std::unique_ptr<TGCheckButton> toggle_measurement;
    enum BUTTON
    {
      TB_OK,
      TB_APPLY,
      TB_CANCEL, 
      CB_TOGGLE
    };
    public:
    DelayLineDialog(const TGWindow *main, camac::EnergyCalibrationCamac *, measurement::EnergyCalibration * EC);
    ~DelayLineDialog(void);
    void ReadDelay(void);
    void WriteDelay(void);
    Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);
  };
}
#endif

