// =====================================================================================
//
//       Filename:  ECReasonDialog.cpp
//
//    Description:  
//
//        Version:  1.0
//        Created:  11.12.2014 14:16:45
//       Revision:  none
//       Compiler:  g++
//
//         Author:  Ivan B. Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
//   Organization:  Budker Institute of Nuclear Physics
//
// =====================================================================================

#include "ECReasonDialog.h"
#include "V4Par.h"
#include <Log.h>

namespace gui
{
	ECReasonDialog::ECReasonDialog(const TGWindow *w, int * r) : TGTransientFrame(gClient->GetRoot(),w,720,110)
	{
    reason = r;
		fLabel.reset( new TGLabel(this,"ENERGY CALIBRATION REASON"));
    TGLayoutHints * ll = new TGLayoutHints(kLHintsExpandX |  kLHintsTop, 10,10,10,10 );
    AddFrame(fLabel.get(),ll);

    TGLayoutHints * lb = new TGLayoutHints(kLHintsExpandX |  kLHintsBottom, 10,10,10,10 );
		fButtonFrame.reset(new TGHorizontalFrame(this));
    auto make_button = [&](std::string name, int id)
    {
      fButton[name].reset(new TGTextButton(fButtonFrame.get(), name.c_str(), id));
      fButtonFrame->AddFrame(fButton[name].get(),lb);
      fButton[name]->Associate(this);
    };
    make_button("REGULAR",EC_REGULAR);
    make_button("AFTER MODE CHANGE",EC_MODE);
    make_button("AFTER CYCLE",EC_CYCLE);
    make_button("OTHER",EC_OTHER);
    AddFrame(fButtonFrame.get(),lb);

		Layout();
    MapSubwindows();
    MapWindow();
    SetSize(GetDefaultSize());
    SetWindowName("Energy Calibration Reason");
    fClient->WaitFor(this);
	}
	ECReasonDialog::~ECReasonDialog(void)
	{

	}
	Bool_t ECReasonDialog::ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 )
	{
		switch( GET_MSG(msg) )	
		{
			case kC_COMMAND:
				switch (GET_SUBMSG(msg)) 
				{
					case kCM_BUTTON:
            * reason  =  parm1;
            std::cout << "EC reason: " << * reason << std::endl;
            delete this;
						break; //end of switch param 1
				} //end of GET_SUBMSG(msg)
				break; //end of kC_COMMAND
		}//end of GET_MSG(msg)
		return kTRUE;
	}
}
