// =====================================================================================
//
//       Filename:  ECReasonDialog.h
//
//    Description:  Reason of the Energy calibration
//
//        Version:  1.0
//        Created:  11.12.2014 14:14:10
//       Revision:  none
//       Compiler:  g++
//
//         Author:  Ivan B. Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
//   Organization:  Budker Institute of Nuclear Physics
//
// =====================================================================================
#pragma once

#include <memory>
#include <map>

#include <TGFrame.h>
#include <TGLabel.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TGNumberEntry.h>

#include "measurement/EnergyCalibrationConfig.h"
#include "LabeledNumberEntry.h"



namespace gui
{
	enum ECReason
	{
    EC_NONE = 0,
    EC_REGULAR = 1,
    EC_MODE = 2,
    EC_CYCLE = 3,
    EC_OTHER = 100
	};


	class ECReasonDialog : public TGTransientFrame
	{
		int * reason;
		public:
			ECReasonDialog(const TGWindow * w, int * r);
			~ECReasonDialog(void);
			Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
      void CloseWindow(void){*reason=-1; delete this;}
		private:
			std::unique_ptr<TGLabel> fLabel;
      std::unique_ptr<TGHorizontalFrame> fButtonFrame;
      std::map<std::string, std::unique_ptr<TGTextButton> > fButton;
			std::unique_ptr<TGLayoutHints> fButtonLayout;
	};
}
