#pragma once
#include <vector>

#include <TGFrame.h>
#include <TGNumberEntry.h>
#include <TGLabel.h>
#include <TGButton.h>

#include "measurement/EnergyCalibrationConfig.h"

namespace gui
{
  class EnergyEntry : public TGGroupFrame 
  {
    public:
      EnergyEntry(const TGWindow * main,const std::string & name, measurement::EnergyCalibrationConfig *d, int option=0); 
      ~EnergyEntry(void);
      void EditEnable(void);
      void EditDisable(void);
      void SetData(const measurement::EnergyCalibrationConfig * );
      void GetData(measurement::EnergyCalibrationConfig * ) const;
      bool GetState(void) { return isedit; }
      TGNumberEntry * ne_energy, *ne_error, *ne_nmr;//, *ne_temp;
    private:
      TGHorizontalFrame * f_energy,*f_nmr;//,*f_temp;
      TGLabel * l_energy,*l_energy_error,*l_nmr;//,*l_temp;
      TGLayoutHints *lf,*lr,*ll;
      bool isedit;
  };

  class ExpectedEnergyDialog : public TGTransientFrame 
  {
    public:
      ExpectedEnergyDialog(const TGWindow * w,measurement::EnergyCalibrationConfig *, measurement::EnergyCalibrationConfig * , int * );
      ~ExpectedEnergyDialog(void);
      Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
      void CloseWindow(void);
    private:
      measurement::EnergyCalibrationConfig *cur,*old;
      measurement::EnergyCalibrationConfig var_old,var_cur;
      double NMR,T,alpha_t;
      EnergyEntry *gcur, *gold;

      TGLayoutHints *bl,*el;

      TGHorizontalFrame * bf;
      std::vector<std::string> b_name;
      std::vector<TGTextButton*> b;
      int * retval;
  };
}
