#ifndef IBN_GUI_GRAPH_H
#define IBN_GUI_GRAPH_H

#include <TGraphErrors.h>
#include "Data.h"
namespace gui
{
  class Graph	: public TGraphErrors
  {
    bool isdraw;
    unsigned last_size; /* last xData size */
    bool localX, localY;
    public:
		//int bunch;
		//int counter;
		//int pair;
    Data *X; /*  X axsis data */
    Data *Y; /*  Y axsis data */
    data::Array & xData; //here is data on axis x
    data::Array & yData; //here is data on axis y
    int index_max;
    int index_min;

    void SetPoint(int i, const ibn::valer<double>::reference & x, const ibn::valer<double>::reference & y)
    {
      TGraphErrors::SetPoint(i,x.value,y.value);
      TGraphErrors::SetPointError(i,x.error,y.error);
    }
    void SetPoint(int i, data::PhysValue & x, data::PhysValue & y)
    {
      TGraphErrors::SetPoint(i,x.value,y.value);
      TGraphErrors::SetPointError(i,x.error,y.error);
    }


    Graph(data::Array *x, data::Array *y);
    Graph(Data * x, Data * y);
    Graph(data::Array *x, Data * y);
    Graph(Data * x, data::Array * y);

    ~Graph(void);

    void Update(void);
    void Clear(void);
    bool IsDraw(void) const {return isdraw; }
    void SetDraw(bool draw=true) {isdraw=true;}
    double GetMaximum() const { return index_max >=0 ?  yData[index_max].value + 1.5*yData[index_max].error  : -1111;}
    double GetMinimum() const { return index_min >=0 ?  yData[index_min].value - 1.5*yData[index_min].error  : -1111;}
		void SetXRangeUser(double tmin,  double tmax); 
		void SetYRangeUser(double ymin,  double ymax); 
		//find maximum of last n points
		double GetMaximum(double n);
		double GetMinimum(double n);
  };
}
#endif
