// =====================================================================================
//
//       Filename:  LabeledNumberEntry.h
//
//    Description:  Number Entry with label
//
//        Version:  1.0
//        Created:  11.12.2014 15:40:15
//       Revision:  none
//       Compiler:  g++
//
//         Author:  Ivan B. Nikolaev (ekherit), I.B.Nikolaev@inp.nsk.su
//   Organization:  Budker Institute of Nuclear Physics
//
// =====================================================================================

#ifndef  LabeledNumberEntry_INC
#define  LabeledNumberEntry_INC
#include <TGNumberEntry.h>
namespace gui
{
	class LabeledNumberEntry : public TGHorizontalFrame
	{
		std::unique_ptr<TGNumberEntry> fNumberEntry;
		std::unique_ptr<TGLabel> fLabel;
		std::unique_ptr<TGLayoutHints> fLabelLayout;
		std::unique_ptr<TGLayoutHints> fEntryLayout;
		int fEntryId;
		public:
      LabeledNumberEntry(const TGWindow *w,  std::string label, TGNumberFormat::EStyle format, double  data, int id,  int digit_number=12) : TGHorizontalFrame(w)
			{
				fLabelLayout.reset(new TGLayoutHints(kLHintsLeft,2,2,2,2));
				fEntryLayout.reset(new TGLayoutHints(kLHintsRight,2,2,2,2));
				fLabel.reset(new TGLabel(this,  label.c_str()));
				fEntryId = id;
				fNumberEntry.reset(new TGNumberEntry(this,data,digit_number,fEntryId,format));
				fNumberEntry->Associate(w);
				AddFrame(fLabel.get(),  fLabelLayout.get());
				AddFrame(fNumberEntry.get(),  fEntryLayout.get());
			}
			~LabeledNumberEntry(void)
			{
			}
			void SetFocus(void) { fNumberEntry->GetNumberEntry()->SetFocus();}
			double GetData(void) { return fNumberEntry->GetNumber();}
			int GetIntNumber(void) { return fNumberEntry->GetIntNumber();}
			void SetData(double data) { fNumberEntry->SetNumber(data);}
			void SetNumber(double data) { fNumberEntry->SetNumber(data);}
			void SetIntNumber(int data) { fNumberEntry->SetIntNumber(data);}
	};
}
#endif   // ----- #ifndef LabeledNumberEntry_INC  ----- 
