#pragma once
#include <memory>
#include<map>

#include <TGMenu.h>
#include <TFrame.h>
#include <TGButton.h>

namespace gui
{
	class MeasurementViewDialog;
	class MeasurementManagerDialog;
	class ScanConfigFrame;
	class BunchViewFrame;
  class MainWindow : public TGMainFrame
  {
    public:
      MainWindow(const TGWindow *w);
      ~MainWindow(void);
      Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
      void CloseWindow(void);
      MeasurementViewDialog * mview;
			std::unique_ptr<MeasurementManagerDialog> gmanager; //gui measurement manager (communicate with user)
      void Run(volatile bool &);
			void StopRun(void) { fIsRun=false; }
      void Update(void);
    private:
      bool ismeasure;
      bool fIsRun=true;;
      typedef std::map<unsigned, std::unique_ptr<TGTextButton> > bmap_t;
      bmap_t b;
      TGLayoutHints * b_layout;
      void LockButton(unsigned);
      void UnLockButton(void);
      /* menus */
      std::unique_ptr<TGMenuBar> MenuBar;
      /* here is all options for control but i doubt about GraphicsMenu */
			std::unique_ptr<TGPopupMenu> FileMenu;
			std::unique_ptr<TGPopupMenu> WindowMenu;
			std::unique_ptr<TGPopupMenu> SettingsMenu;
			std::unique_ptr<TGPopupMenu> ViewMenu;
			std::unique_ptr<TGPopupMenu> OptionsMenu;
			std::unique_ptr<TGPopupMenu> HelpMenu;
      //TGPopupMenu	*FileMenu, *WindowMenu, *SettingsMenu, *OptionsMenu, *HelpMenu;
      TGLayoutHints * MenuBarItemLayout, * MenuBarLayout; 
      /* vidget ids */

      std::auto_ptr<ScanConfigFrame> depcfg_frame; //depolarizer configuration frame
      std::auto_ptr<BunchViewFrame> bunch_view_frame;
			//TRootEmbeddedCanvas * canvas;
      enum	
      {
        M_FILE_SAVE,
        M_FILE_SAVE_AS,
        M_FILE_LOAD,
        M_FILE_RESTORE,
        M_FILE_PRINT,
        M_FILE_EXIT,
        M_FILE_DB,
        M_FILE_LOAD_BAD_POINT_LIST,
        M_FILE_SAVE_BAD_POINT_LIST,
        M_SET_FIT,
        M_SET_CONCUR_CFG,
        M_SET_GRAPHICS,
        M_SET_DEPOLARISATOR_CFG,
        M_SET_COUNTERS,
        M_SET_CALCULATOR,
        M_SET_DELAYLINE,
        M_SET_RARE,
        M_SET_UNRARE, 
        M_SET_REMEMBER_GRAPH_LIST,
				M_HELP_CURRENT_INSTRUCTION, 
				M_HELP_POLARIMETER_INSTRUCTION, 
				M_HELP_NMR_STABILIZATION_INSTRUCTION, 
				M_HELP_ABOUT,
        M_VIEW_ORDER_CANVAS
      };
  };
}
