#pragma once

#include <memory>

#include <TGFrame.h>
#include <TGButton.h>
#include <TGLabel.h>

#include "measurement/EnergyCalibrationConfig.h"

namespace gui
{
	class ScanConfigFrame;
	class LabeledNumberEntry;
  class MeasurementConfigDialog : public TGTransientFrame
  {
    public:
      MeasurementConfigDialog(const TGWindow * w, measurement::EnergyCalibrationConfig * , int * ,  bool count_only=false);
      ~MeasurementConfigDialog(void);
      Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
      void GetData(measurement::EnergyCalibrationConfig *) const;
      void SetData(const measurement::EnergyCalibrationConfig *);
      void CloseWindow(void);
      void Reset(void);
    private:
			bool isCountOnly;
      TGLayoutHints * nel;
			std::unique_ptr<LabeledNumberEntry> fRunNumberEntry;
			std::unique_ptr<LabeledNumberEntry> fCountTimeNumberEntry;
			std::unique_ptr<LabeledNumberEntry> fShowLastPointsNumberEntry;
			//std::unique_ptr<TGLabel> een; //expected energy label

			std::unique_ptr<ScanConfigFrame>  fe;
      measurement::EnergyCalibrationConfig  *cfg;
      measurement::EnergyCalibrationConfig  initial_config;

			std::unique_ptr<TGLayoutHints> lf, lr, ll; 
			std::unique_ptr<TGLayoutHints> bl;
			std::unique_ptr <TGHorizontalFrame> bf;
      std::vector<std::string> b_name;
      std::vector<std::unique_ptr<TGTextButton> > b;
      int * retval;

  };
}
