#pragma once
#include <string>
#include <map> 

#include <boost/filesystem.hpp>
#include <boost/signals2.hpp>

#include "measurement/EnergyCalibrationConfig.h"
#include "data/Calculator.h"
namespace measurement
{
	class Manager;
	class Depolarisator;
}
namespace data
{
	class EnergyCalibrationStorage;
}

namespace  fit
{
	class FitManager;
}

namespace gui
{
	class MainWindow;
	class EnergyCalibrationView;
	class MeasurementViewDialog;
  class MeasurementManagerDialog  
  {
    public:
      MeasurementManagerDialog(MainWindow * );

      ~MeasurementManagerDialog(void);

			void Stop(void); //stop all measurements
			int Measure(int );

			//std::map<std::string,  std::list<measurement::EnergyCalibrationConfig>> GetMeasurementList(void);
			typedef std::vector< std::pair< std::string,  std::list<measurement::EnergyCalibrationConfig> > > Mlist_t;
			const Mlist_t & GetMeasurementConfigList(void) const { return fMeasurementConfigList; };
			Mlist_t  LoadMeasurementConfigList(void);

			Mlist_t fMeasurementConfigList;


			measurement::EnergyCalibrationConfig  LoadMeasurementConfig(std::string);
      void SaveMeasurementConfig(const measurement::EnergyCalibrationConfig & cfg,  std::string filename);

      void Save2FS(boost::filesystem::path, const char * prefix);
      void Save2FS(void);
      void SaveBad2FS(void);

      void Save2DB(void);
      void Print(void);
      void PrintBad(void);

      void Update(void);


      measurement::Manager * manager;
      measurement::Depolarisator * depolarisator;//отвечает за управления деполяризатора
      data::EnergyCalibrationStorage* EC;

      gui::EnergyCalibrationView * ECView;
      fit::FitManager * fitManager;

      data::Calculator calculator;
    private:
      void Loop(MeasurementViewDialog *);
      MainWindow * mode_dialog;

      //std::string POLDIR;

      bool isdepolon;
			boost::signals2::connection new_point_connection;
  };
}
