#pragma once

#include <boost/signals2.hpp>

#include <TGFrame.h>

class TGLabel;
class TGLayoutHints;
class TGNumberEntry;
class TGHProgressBar;

namespace measurement
{
	class Manager;
}

namespace fit
{
	class FitManager;
}

namespace gui
{
	class MainWindow;
	class EnergyCalibrationView;
	class ScanConfigFrame;
	

	class MeasurementViewDialog : public TGGroupFrame 
	{
		public:

			MeasurementViewDialog(TGWindow *w, gui::EnergyCalibrationView *, fit::FitManager *, measurement::Manager *);

			~MeasurementViewDialog(void);

			void CloseWindow(void);

			Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );

			void Update(void);
			void Notify2(void) { isupdateble = true; }
			void SetScanParameters(void);
			int retval;

		private:
			measurement::Manager *polarimeter; //главный класс, который отвечает за все, что происходит (кроме gui)
			EnergyCalibrationView * ECView;
			fit::FitManager * fitManager;
			MainWindow * m_dialog;

			//TGLabel  *range_l, *speed_l, *step_l; 
			TGLabel *measured_frequency_l;

      std::map<std::string, std::unique_ptr<TGLabel>> labels; //list of labels
      std::unique_ptr<TGNumberEntry> range_ne, att_ne; //attenuation number entry


			std::unique_ptr<ScanConfigFrame> fScanConfigFrame;

      std::list<std::unique_ptr<TGHorizontalFrame>> hframes; //list of all unnamed frames
      std::list<std::unique_ptr<TGLayoutHints>> lhints; //list of layout hints

			//TGLayoutHints *bl;
			//TGHorizontalFrame * bf;
			std::vector<std::string> b_name;
			std::vector<std::unique_ptr<TGTextButton>> b;
			volatile bool isupdateble;
			boost::signals2::connection sig_con;

      std::unique_ptr<TGHProgressBar> scan_progress_bar;
      Pixel_t bar_color;
      Pixel_t fg_color;
	};
}
