#ifndef IBN_GUI_NOTE_H
#define IBN_GUI_NOTE_H

#include <vector>
#include <list>
#include <map>
#include <memory>

#include <TText.h>


namespace gui   
{
	class Note  
  {
    static const unsigned BUF = 128;
    public:
    Note(void);
    Note(unsigned);
    Note(unsigned size, TText *);
    ~Note(void);
    void SetNotes(const std::vector<double> & data, const std::vector<double> & X,  const std::vector <double> & Y);
    void SetNotes(size_t size, double * data, double * X,  double * Y);
    void AddNote(TText *);
    void AddNote(const char *, double x, double y);
    void AddNote(double, double x, double y);
    void SetY(double);
    void SetXY(double *, double *);
    void SetSize(double);
    void SetAngle(double);
    void SetRare(unsigned r) { rare=r;}
    void Rare(unsigned n=2); /* Rare data */
    void Unrare(void);
    void Draw(void);
    unsigned GetSize(void) const { return Notes.size();}
    double GetTotalTextSize(void);
    struct Note_t
    {
      int n=0; //number of point
      double x=0; //x position
      double y=0; //y position
      double data=0; //data to draw
      std::string label; //text to draw
			TText text;
			Note_t(void) { }
			Note_t(const Note_t & note)
			{
				n=note.n; //number of point
      	x=note.x; //x position
      	y=note.y; //y position
      	data=note.data; //data to draw
      	label=note.label; //text to draw
				text=note.text; //Ttext
			}
    };
		std::list<Note_t> &  GetList(void) { return Notes;};
    private:
    void Cons(void);
    std::string get_label(int n, double data);
    double size;
    double angle; //в градусах;
    bool isdraw;
    unsigned rare;

    std::list<Note_t> Notes;
  };
}//end of namespace gui
#endif //IBN_GUI_NOTE_H
