#ifndef IBN_GUI_UTILS_H
#define IBN_GUI_UTILS_H
#include <string>

#include <sstream>
#include <iostream>
#include <iomanip>

#include <TGraphErrors.h>
#include <ibn/valer.h>
namespace gui	
{

  inline void SetPoint(TGraphErrors * graph, int i, ibn::valer<double> x, ibn::valer<double> y)
  {
    graph->SetPoint(i,x.value,y.value);
    graph->SetPointError(i,x.error,y.error);
  }


	template <class T> std::string setString( T  t, unsigned w=9 , unsigned prec = 8)
        {
            std::ostringstream ostr;
            ostr.setf(std::ios::left);
            //ostr <<  std::setw(w) << std::setprecision(prec) << t;
            ostr << std::setprecision(prec) << t;
            std::string s = ostr.str();
            return s;
        }

	template <class T> void getData(const char * str, T &t)	
        {
            std::istringstream istr(str);
            istr >> t;
        }
	
	template <class T> T getData(const char *str)
	{
            std::istringstream istr(str);
            T data;
            istr >> data;
            return data;
	}
}
#endif
