#ifndef IBN_GUI_DATA_VOLUME_H
#define IBN_GUI_DATA_VOLUME_H
#include <memory>
#include <algorithm>
#include "Data.h"
namespace gui
{
  class VolumeData : public Data
  {
    data::Array * SIGMAX;
    data::Array * SIGMAZ;
    data::Array * TIME;
    public:

      VolumeData(data::Array * sdx, data::Array * sdz,  data::Array * tm, std::string nm="", std::string at="")
        : Data(nm,nm,at)
      {
        SIGMAX = sdx;
        SIGMAZ = sdz;
        TIME = tm;
        data = new data::Array;
        Update();
      }

      ~VolumeData(void)
      {
        delete data;
      }

      void Update(void)
      {
        size_t size = TIME->size();
        if(data->size()>=size) return;
        data->resize(size);
        show.resize(size);
        for(unsigned i=0;i<size; i++)
        {
					ibn::valer<double> volume = (*SIGMAX)[i]*(*SIGMAZ)[i];
          (*data)[i]=volume;
          show[i]=1;
        }
      }
  };//class DataNoSlope
} //namespace gui
#endif
