#ifndef SMV_MEASUREMENT_COUNTERCALIBRATE_H
#define SMV_MEASUREMENT_COUNTERCALIBRATE_H

#include "../camac/Zcp.h"
#include "EnergyCalibrationCamac.h"
#include <pthread.h>
#include <vector>
#include "../camac/ModuleInventory.h"

namespace measurement
{

	
class CounterCalibrate_by_Landao
	{
	public:
//		CounterCalibrate(void){}
		CounterCalibrate_by_Landao(camac::EnergyCalibrationCamac*);
		~CounterCalibrate_by_Landao(void);
		void SetVviVolt(unsigned, unsigned);
		void SetDiskr(unsigned, unsigned);
		void Start(void);
		void Stop(void);
		double GetCurrentMeasurement(void);
		bool IsMeasure(void);
		bool is_measure;
	private:
		pthread_mutex_t lock_counter_calibrate;
		friend void* GetDataFromZcp(void*);
		camac::Zcp* ZCP;//- 
		camac::EnergyCalibrationCamac* ECCamac; //    EnergyCalibrayion				
		unsigned counter_num; //number of counter which use in current time
		std::vector<double> data_array;
		double current_data;	
		pthread_t GETDATAFROMZCP_THREAD;
		//pthread_mutex_t lock_counter_calibrate; //
	};







//============================================================================
//     "" .
//  ,    ,      .
//   .     ,    EnergyCalibration.
//         ( )  
//   ( ). ..       ,  
//  ,    .      .
//     , ,  ,
//     .
//    !
//!
/*
class CounterCalibrate_by_ClassicMethod
	{
	typedef double Value_t;
	public:
		CounterCalibrate_by_ClassicMethod(CounterCalibr_Calssic_begin_date*);
		~CounterCalibrate_by_ClassicMethod(void);
		void Start(void);		
		void Stop(void);		
		std::vector<data::PhysValue> data_array; //  
	private:
		friend void* Start_Counter_Calibr_Classic_in_tread(void *);	
		camac::EnergyCalibrationCamac* EC;
		unsigned counter_num, volt_begin, volt_end; //,     ,  
		double count_time; //,     ,  	
		FillData();
		pthread_t measure_thread;  
	};

*/

}
#endif
