#pragma once
#include <iostream>
#include <string>
#include <thread>
#include <mutex>
#include <memory>

#include <ibn/averager.h>
#include <ibn/valer.h>

#include <camac/Freq.h>
#include "data/Storage.h"
#include "Measurement.h"

namespace measurement
{
	class FrequencyMeasurement : public Measurement
	{
		public:
			FrequencyMeasurement(void);
			virtual ~FrequencyMeasurement(void);
			void Start(void);
			void Stop(void);
			void Measure(void);
			void Pause(void) {};
			void UnPause(void) {};
			void Continue(void) {};
			bool IsMeasure(void) const {return fIsMeasure;}
			data::Storage * GetStorage (void){ return nullptr; }
			ibn::valer<double> GetCurrentFrequency(void) const { return fCurrent_freq; } 
			ibn::valer<double> GetAverageFrequency(void) const { return fFreq;  } 
			void SetFrequencymeter(camac::Freq *freq) { fFrequencymeter = freq; }
			void MakeNewPoint(void);
		private:
			std::thread fThread;
			volatile bool fIsMeasure;
			ibn::valer<double> fFreq; //average frequency
			ibn::valer<double> fCurrent_freq; //instant frequency of last measured
			ibn::averager<double> fFa; //frequency averager
			camac::Freq * fFrequencymeter;
			std::mutex mutex;
	};
}
