#ifndef IBN_MEASUREMENT_FREQUENCYMETER_H
#define IBN_MEASUREMENT_FREQUENCYMETER_H

#include <pthread.h>
#include "camac/Freq.h"
#include "camac/Commutator.h"

namespace   measurement
{
	class Frequencymeter    :  private camac::Freq 
  {
		public:
			Frequencymeter(void){};
			Frequencymeter(const camac::Address &, const camac::Address &);
			double GetMeasuredFrequency(void);
			void StartMeasurement(void);
			void SetFrequencyError(double f)  {freq_error = f;}
			double GetFrequencyError(void)  const {return freq_error;}
			bool IsMeasure(void) const { return ismeasure; }
			void StopMeasurement(void);
			//double Calibrate(unsigned, camac::Commutator *);	
			//camac::Freq::Bind;
		private:
			void WriteDataFile(void);
			bool ismeasure;
			double MFr; //измеренная частота
			pthread_t thread;
			static void * Measure(void * );
			double freq_error;
	}; // end of class Frequencymeter

	class FrequencymeterWithCalibration : public Frequencymeter
  {
		public:
			enum WHAT { DEP = 0, REZ = 1, CAL = 2};
			enum WHEN { FIRST, SECOND };
			FrequencymeterWithCalibration(void);
			//FrequencymeterWithCalibration(const camac::Address &, const camac::Address &, const camac::Address &, camac::Commutator *, unsigned , WHAT md);
			void Bind(const camac::Address &, const camac::Address &, const camac::Address &, camac::Commutator *, unsigned, WHAT md);
			~FrequencymeterWithCalibration(void){ delete comm; }
			void SetWorkMode(WHAT md) { workMode = md;  SetWorkMode(); }
			void SetWorkMode(void) { SetMode(workMode); }
			void SetMode(WHAT);
			WHAT GetWorkMode(void)  const { return workMode;    }
			double GetCalibration(WHEN time, WHAT md) const { return calib[md][time]; }
			void Clear(void)    { for(int i=0; i<3; i++) for(int j=0; j<2; j++) calib[i][j]=0; }
			void Calibrate(WHEN time , WHAT md);
			//что измеряем
		private:
			double calib[3][2];
			WHAT workMode; //рабочий режим ( во время набора ститистики)
			unsigned COMM; //какому каналу коммутатора соответстует;
			camac::Commutator *razv, *comm;
	};

} //end of namespase measurement
#endif //IBN_MEASUREMENT_FREQUENCYMETER_H

