#include "../Opt.h"
#include "../camac/Attenuator.h"
#include <iomanip>
#include <iostream>


void usage(void)	{
		cout << "Usage: attenuator -a <camac_address> [ read | write <data> | test ]" << endl;
		cout << " <camac_address> is name/interface/crate/position" << endl;
		cout << " <data> in dB\n";
		exit(0);
}
bool camac::Module::NOEXCEPTION=false;
int main (int argc, char ** argv )	{
	unsigned attenuation;
	SimpleOpt opt ( argc, argv );
	if ( opt.is("--help") || opt.is("-h") )	usage();
	string adr;
	if ( ! opt.get("-a",&adr) ) usage();
	camac::Address a(adr,'/');
	try	{
		cout << "Initializing attenuator..." << endl;
		camac::Attenuator attenuator(a);
		if ( opt.is("read") )	{
			cout << attenuator.GetAttenuation() << endl;
		}
		if ( opt.get("write",&attenuation) )	{
			attenuator.SetAttenuation(attenuation);
		}
		int width=10;
		if ( opt.is("test" ) )	{
			cout << setw(width) <<  "write" << setw(width) << "read" << endl;
			int i =0;
			while (i<=32)	{
				attenuator.SetAttenuation(i%16);
				cout << setw(width) << i%16 << setw(width) << attenuator.GetAttenuation() << endl;
				i++;
			}
		}
	}
	catch ( camac::Module::Error e)	{
		cout << e.what()<<endl;;
	}
}
