#include </usr/src/lsi6/lsi6camac.h> 
#include <stdio.h>
#include <unistd.h>
#include <iostream>
#include <cmath>
#include <iomanip>
//#include "opt.h"
using namespace std;
int POSITION;

unsigned long ERROR_NUMBER=0;
unsigned long COUNT=0;
//int TIME=100000;
int TIME=30000;
enum { READ, WRITE, READ_WRITE};
int draw_point( int i, int fd,int mode)
{ 
  int XQ_WRITE=0, XQ_READ=0,XQ=0;  
  int p = log(i)/log(2.0);
  int a =0;
  unsigned long int data = i;
  unsigned long int read_data=0;
  switch (mode)
  {
    case READ:
      XQ_WRITE = CAM24(fd,NAF(POSITION,a,16),&data);
      XQ_READ = CAM24(fd,NAF(POSITION,a,0),&read_data);
      usleep(TIME);
      break;
    case WRITE:
      XQ_WRITE = CAM24(fd,NAF(POSITION,a,16),&data);
      read_data=data;
      usleep(TIME);
      break;
    case READ_WRITE:
      XQ_WRITE = CAM24(fd,NAF(POSITION,a,16),&data);
      usleep(TIME/2);
      XQ_READ = CAM24(fd,NAF(POSITION,a,0),&read_data);
      usleep(TIME/2);
      break;
  }
  COUNT++;
  XQ = XQ_WRITE & XQ_READ;
  cout << setw(5) << mode << setw(10) << p << setw(15) << i << "   XQ="  << setw(10) << left << XQ;
  ERROR_NUMBER+= static_cast<unsigned long>(bool(XQ_WRITE)) + static_cast<unsigned long>(bool(XQ_READ))
    + static_cast<unsigned long> (data!=read_data);
  char buf[128];
  sprintf(buf," %5.2f%% ", 100*double(ERROR_NUMBER)/COUNT);
  std::cout << setw(10) << left << ERROR_NUMBER << setw(10) << COUNT << buf;
  std::cout << "(";
  for(int j=0;j<p;j++) std::cout << " ";
  std::cout << "*";
  for(int j=p+1;j<24;j++) std::cout << " ";
  std::cout << ")";
  std::cout <<  endl;
  return i;
} 








int main(int argc, char ** argv)
{
  //ibn::SimpleOpt opt(argc,argv);
  //int POS;
  //opt.get("--n",POS);
  //cout << POS << endl;
  char program_name[1024];
  int channel;
  int position;
  sscanf(argv[0],"%s",&program_name);
  if(argc!=3)
  {
    cerr << "Usage: " << program_name << "  <channel>  <position>" << endl;
    return 1;
  }

  sscanf(argv[1],"%d",&channel);
  sscanf(argv[2],"%d",&position);
  cout << program_name << " channel=" << channel << " position=" << position << endl;
  POSITION = position;

  char device[1024];
  sprintf(device,"/dev/lsi6card1channel%d",channel+1);
  int fd = open(device,O_RDWR);
  if(fd<0)
    printf("ERROR");
  CAM_C (fd);
  CAM_Z (fd);
  int pos = position;
  int c = 0;
  int j=0;
  while(1)
  {       
    for(int i=1;i<16777216;i<<=1) 
    { 
      draw_point(i,fd,j);
      if(!CAM_LWAIT(fd,pos,0)) j = (++j)%3;
    }
    for(int i=16777216/2;i>=2;i>>=1)  
    {
      draw_point(i,fd,j);
      if(!CAM_LWAIT(fd,pos,0)) j = (++j)%3;
    }
    //printf("%d",j);
  }
  close(fd);
}  

