/*
 * =====================================================================================
 *
 *       Filename:  test_opt.cpp
 *
 *    Description:  Test for ibn::Opt options.
 *
 *        Version:  1.0
 *        Created:  12/21/2009 05:40:40 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physycs, Novosibirsk, Russia
 *
 * =====================================================================================
 */

#include "Opt.h"
#include <iostream>

using namespace std;
int main(int argc, char ** argv)
{

  ibn::Opt opt;
  opt.add("--zero");
  opt.add("--one",1);
  opt.add("--two",2);
  opt.add("--three",3);
  opt.fill(argc,argv);
  if(opt.isopt("--zero"))
  {
    cout << "Hit zero option" << endl;
  }
  vector <string> one(1);
  vector <string> two(2);
  vector <string> three(3);
  if(opt.isopt("--one"))
  {
    opt.getopt("--one",&one);
    cout << "Hit one option with param: " << one[0] << endl;
  }

  if(opt.isopt("--two"))
  {
    opt.getopt("--two",&two);
    cout << "Hit one option with param: " << two[0] << ", " << two[1]<<  endl;
  }

  if(opt.isopt("--three"))
  {
    opt.getopt("--three",&three);
    cout << "Hit one option with param: " 
      << three[0] << ", " 
      << three[1] << ", "
      << three[2] << endl;
  }
}

