#include <iostream>
#include <fstream>
#include <iomanip>

#include "../camac/Counter.h"
#include "../camac/Timer.h"

#include <unistd.h>

#include <boost/program_options.hpp>
#include <boost/program_options/errors.hpp>


using namespace std;

int main(int argc, char ** argv)    {
    namespace po=boost::program_options;
    po::options_description opt_desc("Usage:");
    opt_desc.add_options()
	("help","Print this help")
	("timer","Address of timer in format interface:crate:station")
	("counter","Address of counter in format interface:crate:station:channel")
	("time","Measurement time [sec]");

    po::variables_map opt;
    try {
	po::store(po::parse_command_line(argc, argv, opt_desc), opt);
	po::notify(opt);

	if (opt.count("help") )
	{
	    cout << opt_desc;
	    cout << "Example: "<< endl;
	    cout << "count --timer 0";
	    return 1;
	}
    }
    catch (boost::program_options::error po_error) {
	cerr << po_error.what() << endl;
    }

    return 0;
}

