/* This proram is to find jump in polarimeter data */
#include<iostream>
#include<sstream>
#include<fstream>

#include<vector>
#include<valarray>
//#include<fit/Fit.h>

#include "TROOT.h"
#include "TSystem.h"
#include "TApplication.h"

#include "TStyle.h"

#include "TCanvas.h"
#include "TH1.h"
#include "TGraph.h"

#include "TGraphErrors.h"
#include "TAxis.h"


#include<TText.h>

//   
inline bool is(istream &is,char Ch)    {
	char c;
	is.get(c);
	if( c == Ch)	{
		is.putback(c);
		return true;
	}
	is.putback(c);
	return false;
}

/* ============== for ROOT ==========================*/
R__EXTERN TSystem *gSystem;
extern void InitGui();
VoidFuncPtr_t initfuncs[] = { InitGui, 0 };
TROOT root("qwe","qwe", initfuncs);
/*====================================================*/

int main(int argc, char ** argv)   {
	/* start ROOT application */
	TApplication theApp("App", &argc, argv);
	ifstream fdata(argv[argc-1]);
	vector<TText*> FreqText;
	double time,delta,delta_err;
	TGraphErrors * graph = new TGraphErrors();

	TCanvas *Canvas = new TCanvas("Delta","Delta",700,500);
	graph->SetTitle("Delta");
	graph->SetMarkerStyle(20);
	graph->SetMarkerColor(kRed);
	Canvas->SetGridx();
	Canvas->SetGridy();
	valarray<double> freq(10000);
	for(unsigned long i = 0; !fdata.eof(); i++)  {
		//     
		cerr <<"test\n" <<flush;
		cerr << "erfefef" <<endl;
		while(is(fdata,'#')) fdata.ignore(1000,'\n');
		fdata >> time >> freq[i] >> delta >> delta_err;
		fdata.ignore(1000,'\n');

		if(time >3200) {
			break;
		};
		graph->SetPoint(i,time,delta);
		graph->SetPointError(i,0,delta_err);

		ostringstream ost;
		ost << freq[i];
		FreqText.push_back(new TText(time,delta,ost.str().c_str()));
		FreqText[i]->SetTextAngle(90);
		FreqText[i]->SetTextSize(0.035);

	};
	graph->Draw("AP");
	fit::FitJump(graph,200,freq,20,2,10,12);

	graph->GetXaxis()->SetTitle("Time,sec");
	graph->GetYaxis()->SetTitle("Delta,%");
	for(int i = 0; i< graph->GetN(); i++)   {
		FreqText[i]->SetY(graph->GetHistogram()->GetMinimum());
		if(freq[i]!=0) FreqText[i] ->Draw();
	}

	gStyle->SetOptFit();
	Canvas->Modified();
	Canvas->Update();

	theApp.Run();theApp.Terminate();
}
