#ifndef SMV_GETLANDAO_H
#define SMV_GETLANDAO_H

#include<iostream.h>
#include<string>
#include"../camac/Diskr.h"
#include"../camac/Vvi.h"
#include"../camac/Form.h"
#include"../camac/Zcp.h"
#include"../camac/Liza.h"
extern "C"	{
#include"../config/parsecfg-3.2.1/parsecfg.h"
}

struct GetlandaoAddr	{
	char* formStr;
	char* delayStr;
	char* diskrStr;
	char* vviStr;
	char* zcpStr;
	char* file;
};



class Getlandao
	{
		public:						 	
			Getlandao( const struct GetlandaoAddr);
			Getlandao(const char* = "Landao.cfg");
			~Getlandao();
			inline void setForm(unsigned int = 160);
			inline void setDelay(unsigned int = 0);
			inline void setDiskr(unsigned int = 25);
			inline void setVvi(unsigned int = 0);
			inline void start(unsigned int = 1);       // file out
			inline void start_print(unsigned int = 1); // display out
			inline void setAddr(const struct GetlandaoAddr);	
		private:
			camac::Liza delay;
			camac::Form form; // 
			camac::Diskr diskr;
			camac::Vvi vvi;
			camac::Zcp zcp;
      FILE *OutDataFile;
	};


//=======================================================================================================================================

Getlandao::Getlandao(const char* filenameCfg = "Landao.cfg")
{
struct GetlandaoAddr adr;
		cfgStruct cfgaddr[]={
			{"DISKRIMINATOR"	,CFG_STRING	,&adr.diskrStr},
			{"VVI"			,CFG_STRING	,&adr.vviStr},
			{"FORMIROVATEL"		,CFG_STRING	,&adr.formStr},
			{"ZCP"			,CFG_STRING	,&adr.zcpStr },
			{"LINIA_ZADERGKI"	,CFG_STRING	,&adr.delayStr},
			{"FILENAME", CFG_STRING, &adr.file},
			{0, CFG_END, 0}
		};
	  cfgParse(filenameCfg ,cfgaddr,CFG_SIMPLE);
	  Getlandao::setAddr(adr);
}

//=========================================================

Getlandao::Getlandao(const struct GetlandaoAddr  adr)
	{
	setAddr(adr);	
	}

//===========================================================

void Getlandao::setAddr(const struct GetlandaoAddr  Addr)
	{
	const camac::Address adfr(Addr.formStr);
	form.Bind(adfr, 160);
	
	const camac::Address adliz( Addr.delayStr);
	delay.Bind(adliz);

	const camac::Address addiskr(Addr.diskrStr);
	diskr.Bind(addiskr);

	const camac::Address advvi(Addr.vviStr);
	vvi.Bind(advvi);
	
	const camac::Address adzcp(Addr.zcpStr);
	zcp.Bind(adzcp);
	
	if ((OutDataFile = fopen(Addr.file, "a+")) == NULL)
		{
		printf("Bad file LandaoData.dat\n");
		exit(EXIT_FAILURE);
		}	
	}

//=======================


Getlandao::~Getlandao()
	{
	fclose(OutDataFile);
	}

//=======================

inline void Getlandao::setForm(unsigned int time = 160)
	{
	form.SetTime(time);
	}

//=======================

inline void Getlandao::setDelay(unsigned int time =0 )
	{
	delay.SetTime(time);
	}

//=======================

inline void Getlandao::setDiskr(unsigned int u = 25)
	{	
	diskr.SetThreshold(u);
	}

//=======================

inline void Getlandao::setVvi(unsigned int volt = 0)
	{	
	vvi.SetVolts(volt);
	}

//=======================

inline void Getlandao::start(unsigned int i = 1)
	{
	zcp.WaitLam();
	zcp.GetData();
	int zdata;
	for (unsigned int  a=1 ; a<=i ; ++a )
		{
		zcp.WaitLam();
		zdata = zcp.GetData();
		fprintf(OutDataFile, "%d\n", zdata);
		fflush(OutDataFile);
		}
	}

//=======================

inline void Getlandao::start_print(unsigned int i = 1)
	{	
	zcp.WaitLam();
	zcp.GetData();
	int zdata;
	for (unsigned int  a=1 ; a<=i ; ++a )
		{
		zcp.WaitLam();
		zdata = zcp.GetData();
		fprintf(OutDataFile, "%d\n", zdata);
		fflush(OutDataFile);
		cout <<a<<": "<<zdata<<endl;
		}
	}

//=======================	
// end of getlandao function


#endif // SMV_GETLANDAO_H
