//#=====================================================================================
//#
//#       Filename:  radiation_test.cpp
//#
//#    Description:  test of radiation module in VdPol/calculations/radiation.h
//#                  it fills histrogram and draw it in corresponding some
//#                  command line parameters 
//#        Version:  1.0
//#        Created:  23.12.2002
//#       Revision:  none
//#       Compiler:  GNU C/C++
//#
//#         Author:  Ivan B. Nikolaev
//#        Company:  BINP,Russia
//#          Email:  I.B.Nikolaev@inp.nsk.su
//#
//#=====================================================================================

#include<iostream>
#include<TRandom.h>
#include<TH1.h>
#include<calculations/radiation.h>
#include<strstream>
#include<Opt.h>

#include "TROOT.h"
#include "TSystem.h"
#include "TApplication.h"
/* ============== for ROOT ==========================*/
R__EXTERN TSystem *gSystem;
extern void InitGui();
VoidFuncPtr_t initfuncs[] = { InitGui, 0 };
TROOT root("qwe","qwe", initfuncs);
/*====================================================*/
#include<TGraph.h>
#include<TCanvas.h>
#include<TF1.h>
int main(int argc, char ** argv) { 
	unsigned Nmax = 10; //amount of event
	double L = 100; //magnet length
	double max_omega = 1000; //maximum omega in histogram
	double H = 2000;		//field in magnet;
	double gam = 3000; //gamma factor
	double omega_c;
	Opt opt("n:l:H:g:");
	opt.add("--max_omega",1);
	opt.add("--max_radprob",1);
	opt.add("--max_omegac",1);
	opt.add("--max_theta_gamma",1);
	opt.fill(argc,argv);	
	opt.getopt("-n",&Nmax);			
	opt.getopt("-l",&L);				
	opt.getopt("-H",&H);
	opt.getopt("-g",&gam);
	opt.getopt("--max_omega",&max_omega);
	opt.getopt("--max_radprob",&radiation::MAX_RADPROB);
	opt.getopt("--max_omegac",&radiation::MAX_OMEGAC);
	opt.getopt("--max_theta_gamma",&radiation::MAX_THETA_GAMMA);
	cout << "Amount of generated events : " << Nmax  << endl;
	cout << "Length of magnet: "	<< L     << endl;
	cout << "Chi parameters : " << radiation::chi(gam,H) << endl;
	omega_c = radiation::me*gam*radiation::chi(gam,H) ;
	cout << "Omega_c : " << omega_c<< endl;
	cout <<	"Maximum omega in histogram : " << max_omega << endl;
	TH1F *theta = new TH1F("theta","theta",200,0,radiation::MAX_THETA_GAMMA);
	TH1F *his = new TH1F("omega","omega",1000,0,radiation::MAX_OMEGAC);
	//TH1F *his = new TH1F("omega","omega",200,0,max_omega);
	radiation::Momentum mom;
	for (unsigned i = 0; i < Nmax ; i++	)	{
		mom = radiation::Radiate(gam,H,L);
		if(mom.pl != 0) {
			//his->Fill(float( sqrt(mom.pl*mom.pl + mom.pr*mom.pr + mom.pz*mom.pz)/gam*radiation::me*radiation::chi(gam,H)));
			double om = sqrt(mom.pl*mom.pl + mom.pr*mom.pr + mom.pz*mom.pz);
			his->Fill(float(om/omega_c));
			theta->Fill(gam*float(sqrt(mom.pz*mom.pz+mom.pr*mom.pr)/om));
		}

		//cout << mom.pl << "  " << mom.pr << "  " << mom.pz << endl;
	}
	TApplication theApp("App", &argc, argv);
	his->Print();

	TCanvas *c1 = new TCanvas("omega","omega",600,300);
	c1->cd();
	his->Draw();
	TCanvas *c2 = new TCanvas("RadProb","RadProb",600,300);
	int N=100;
	double om[N];
	double y[N];
	for(int i = 0; i< N; i++)	{
		om[i] = radiation::MAX_OMEGAC*(i+1)/N;
		y[i] = radiation::Spectr(om[i]);
	}
	TGraph *gr = new TGraph(N,om,y);
	c2->cd();
	theta->Draw();
	TCanvas *c3 = new TCanvas("Spectr","Spectr",600,300);
	c3->cd();
	gr->Draw("la");
	theApp.Run();theApp.Terminate();

}
