/* The program intend for work within energy calibration experiments at VEPP-3, VEPP-4M.
 * The progam work with synthesizer DDS-300. In compliance with input parameters it scans frequency domain where spin resonance frequency exists.
 *
 * date:  28-05-2006
 * author: M.V.Struchalin
 * e-mail: struchalinmaxim@mail.ru
 * 
 * The Budker Institute of Nuclear Physics
 *
*/



#include "../data/Calculator.h"
#include "../measurement/Depolarisator.h"
#include <iostream>
#include "../Utils.h"


unsigned DEBUG = 0;
unsigned Log::debug_level = 1;
std::string Log::program_name = "";
bool Log::is_time = true;

bool WARNING = true;

int main(int argc, char **argv)
{

measurement::Depolarisator depolarisator(camac::Address("0:2:11:-1"));

   
if(argc == 1)
   {
   std::cout<<"Usage: "<<argv[0]<<" <initial_frequency> <final_frequency> <frequency_speed> <frequency_step>\n\n"
	    <<"Author: Maksim V. Struchalin 44-19, 8-913-933-88-46\n";
   return 0;
   }


	
	
   data::MeasurementConfig config;
   


if(argc == 5)
   {
	   
   config.depolarizer.initial   = getData<double>(argv[1]);
   config.depolarizer.final     = getData<double>(argv[2]);
   config.depolarizer.speed     = getData<double>(argv[3]);
   config.depolarizer.step      = getData<double>(argv[4]);
   config.depolarizer.scan_time = config.depolarizer.step/config.depolarizer.speed;
   
   
   
   std::cout<<"initial frequency"<<config.depolarizer.initial<<"\n"
	    <<"final frequency="<<config.depolarizer.final<<"\n"
	    <<"frequency speed="<<config.depolarizer.speed<<"\n"
	    <<"frequency step="<<config.depolarizer.step<<"\n"
	    <<"scannig time="<<config.depolarizer.scan_time<<"\n\n";

   

try
{
	
   depolarisator.StartScan(&config.depolarizer);
  
   
//   pthread_exit(NULL);

    }
    catch(camac::Crate::Error e)    {
        std::cerr << Log(0) << "polarimeter: camac crate error: " <<e.what() << '\n';
        std::cerr << Log(0) << "check crate power or check ppi-crate cable" << '\n';
	return (1);
    }
    catch(camac::Module::Error e)    {
        std::cerr << Log(0) <<"polarimeter: camac module error: " <<e.what() << '\n';
	return (1);
    }
    catch(std::runtime_error e)    {
        std::cerr <<Log(0) << "polarimeter: runtime error: " << e.what() << '\n';
	return (2);
    }
    catch(std::out_of_range e)	{
        std::cerr <<Log(0) << "polarimeter: data is out of range: " << e.what() << '\n';
	return (2);
    }
    catch(std::logic_error e)    {
        std::cerr << Log(0) <<"polarimeter: logic error:  " <<e.what() << '\n';
	return (2);
    }
    catch(...)	{
        std::cerr << Log(0) << "polarimeter: some unrecognize exeption " << '\n';
	return (3);
    }
}   
sleep(100000);   
return 0;
}
