#include<camac/Concur.h>
#include<iostream>
#include<cstdio>
#include<getopt.h>

int main(int argc, char ** argv)    {
    unsigned  mask;
	int interface = -1;
	int crate = -1;
	int station = -1;
    int channel = -1;

	int c;
    int digit_optind = 0;

		 if(argc < 2) {
			 cout << "Program test work of camac module concurrence (L0306)" << endl;
			 cout << "Writen by Ivan B. Nikolaev, 39-41-78 3 NOV 2001" << endl;
			 cout << "Usege: " << argv[0] << " interface/crate/station/channel [option [parameter]]" << endl;
			 cout << "Option is" << endl <<
				 "--set_and mask: set mask for and " <<endl;
             exit(0);
		 }
		 try    {
			 camac::Address adr(argv[1]);
             adr.name = "Concurrence L0306";
			 camac::Concur_L0306 * con = new camac::Concur_L0306(adr);

		 while (1)	{
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
				 {"set_and",1,0,'a'},
				 {"get_and",0,0,'b'}

             };

			 //c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			 c = getopt_long (argc, argv, "",long_options, &option_index);
			 if (c == -1)	break;


			 switch (c)	{
				 case 'a':
				   sscanf(optarg,"%x",&mask);
				   cout << "# Set mask  " << hex<< mask ;;
                   con->SetAndMask(adr.channel,mask);
				   cout << "  [OK] " << endl;
				   break;
                 case 'b':
				   cout << "# Get mask  " << hex;
                   cout << con->GetAndMask(adr.channel);
				   cout << "  [OK] " << endl;
				   break;
				 case '?':
                 break;

               default:
                 printf ("?? getopt returned character code 0%o ??\n", c);
               }
            }

         if (optind < argc-1)
           {
             printf ("non-option ARGV-elements: ");
             while (optind < argc)
             printf ("%s ", argv[optind++]);
             printf ("\n");
		   }

	}
    catch(camac::system_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}

	catch(camac::station_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::logic_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::runtime_error e)    {
		cerr << "\n***** " << e.what() << endl;
	}
}
