#include"camac/Counter.h"

#include<iostream>
#include<cstdio>
#include<getopt.h>
#include<unistd.h>

int main(int argc, char ** argv)    {
	int interface = -1;
	int crate = -1;
	int station = -1;
	int channel = -1;
	int c;
	//int digit_optind = 0;
	if(argc < 2) {
		cout << "Program test work of camac module KC-8 with four 32-bits channels" << endl;
		cout << "Writen by Ivan B. Nikolaev, 39-41-78 27 SEP 2001" << endl;
		cout << "Usege: " << argv[0] << " interface/crate/station/channel [option [parameter]]" << endl;
		cout << "Option is" << endl <<
		 	"--inc times: increment counter on times count" <<endl <<
		 	"--read : read count " << endl <<
			"--reset: reset count " << endl <<
		 	"--read_reset: read count and reset" << endl <<
			"--timer: count while timer works " << endl;
		exit(0);
	}
	sscanf(argv[1],"%d/%d/%d/%d",&interface,&crate,&station,&channel);
	try    {
		//camac::Crate * Crate = new camac::Crate(interface,crate);
		camac::Counter *Counter  = 0;
		camac::Counter *Counter1 = 0;
		camac::Counter *Counter2 = 0;
		camac::Counter *Counter3 = 0;
		if(channel<4) {
			camac::Address adr("Counter",interface,crate,station,channel);
			Counter = new camac::Counter(adr);
			cerr << "test" << endl << flush;
		}
		else    {
			camac::Address adr("Counter",interface,crate,station,0);
			Counter = new camac::Counter(adr);
			adr.channel = 1;
			Counter1 = new camac::Counter(adr);
			adr.channel = 2;
			Counter2 = new camac::Counter(adr);
			adr.channel = 3;
			Counter3 = new camac::Counter(adr);
		}
		while (1)	{
			int option_index = 0;
			static struct option long_options[] =
			{
				{"inc", 1, 0, 'i'},
				{"read", 0, 0, 'r'},
				{"reset",0,0, 1},
				{"read_reset",0,0,2},
				{"timer",0,0,3}
			};
			//c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			c = getopt_long (argc, argv, "",long_options, &option_index);
			if (c == -1)	break;
			unsigned increment;
			switch (c)	{
				case 'i':
					sscanf(optarg,"%u",&increment);
					cout << "# Increment counter on " << increment << " counts";
					Counter->Increment(increment);
					cout << " [OK]" <<endl;
					break;
				case 'r':
					cout << "# counts: ";
					if(Counter) cout << Counter->GetCount() << " ";
					if(Counter1) cout << Counter1->GetCount() << " ";
					if(Counter2) cout << Counter2->GetCount() << " ";
					if(Counter3) cout << Counter3->GetCount() << " ";
					cout << "[OK]" <<endl;
					break;
				case 1:
					cout << "# Reset counts.";
					if(Counter) Counter->ResetCount();
					if(Counter1) Counter1->ResetCount();
					if(Counter2) Counter2->ResetCount();
					if(Counter3) Counter3->ResetCount();
					cout << " [OK]" <<endl;
					break;
				case 2:
					cout << "# Read counts with reset: ";
					if(Counter) cout << Counter->GetCountReset() << " ";
					if(Counter1) cout << Counter1->GetCountReset() << " ";
					if(Counter2) cout << Counter2->GetCountReset() << " ";
					if(Counter3) cout << Counter3->GetCountReset() << " ";
					cout << " [OK]" <<endl;
					break;
				case 3:
					cout << "# Count during timer is work "<<endl;
					for(unsigned i = 0;;i++)  {
						while(Counter->IsCount()) usleep(1000);
						cout << "# " << i << " : ";
						if(Counter)  {
							cout << Counter->GetCount() << " ";
							Counter->ResetCount();
						}
						if(Counter1) {
							cout << Counter1->GetCount() << " ";
							Counter1->ResetCount();
						}
						if(Counter2) {
							cout << Counter2->GetCount() << " ";
							Counter2->ResetCount();
						}
						if(Counter3) {
							cout << Counter3->GetCount() << " ";
							Counter3->ResetCount();
						}
						cout << " [OK]" <<endl;
						while(!Counter->IsCount()) { usleep(1000);}
					}
				case '?':
					break;
				default:
					printf ("?? getopt returned character code 0%o ??\n", c);
					break;
			}
		}

		if (optind < argc-1)	{
			printf ("non-option ARGV-elements: ");
			while (optind < argc)
			printf ("%s ", argv[optind++]);
			printf ("\n");
		}

	 }
	catch(camac::system_error e)	{	cerr << "\n***** " <<e.what() << endl;	}
	catch(camac::station_error e)	{	cerr << "\n***** " <<e.what() << endl;	}
	catch(std::logic_error e)	{	cerr << "\n***** " <<e.what() << endl;	}
	catch(std::runtime_error e)	{	cerr << "\n***** " << e.what() << endl;	}
}
