#include "../camac/Delay.h"
#include<iostream>
#include<string>
#include<stdio.h>
#include<math.h>

/*
 *Programm tests numerical CAMAC delay line L0606.
 *
 *Company: BINP
 *Autor: M.V.Struchalin
 *created: Thu Dec  7 15:11:28 NOVT 2006 
 *contact: struchalinmaxim@mail.ru	
*/

/*
Description:
Address camac block in format "interface:crate:block_addres:subaddres" and step and delay in usec are taken as input parameter.
Block is seted. 
*/

unsigned DEBUG = 0;
unsigned Log::debug_level = 1; //   
std::string Log::program_name = "polarimeter: ";
bool Log::is_time = true;

bool WARNING = true;
std::string Log::log_file = "test_log.dat";




int main(void)
{
std::cout<<"-1"<<"\n";
try
{
std::cout<<"0"<<"\n";


const char * adr_str = "0:5:13:0";
int step             = 5;
int delay                = 5;


camac::DelayLine_L0606 delay_line1_1("delay_line_testing1", camac::Address("0:5:13:0"), step, delay);
camac::DelayLine_L0606 delay_line1_2("delay_line_testing2", camac::Address("0:5:13:1"), step, delay);
camac::DelayLine_L0606 delay_line1_3("delay_line_testing3", camac::Address("0:5:13:2"), step, delay);
camac::DelayLine_L0606 delay_line1_4("delay_line_testing4", camac::Address("0:5:13:3"), step, delay);

camac::DelayLine_L0606 delay_line2_1("delay_line_testing5", camac::Address("0:5:15:0"), step, delay);
camac::DelayLine_L0606 delay_line2_2("delay_line_testing6", camac::Address("0:5:15:1"), step, delay);
camac::DelayLine_L0606 delay_line2_3("delay_line_testing7", camac::Address("0:5:15:2"), step, delay);
camac::DelayLine_L0606 delay_line2_4("delay_line_testing8", camac::Address("0:5:15:3"), step, delay);


camac::DelayLine_L0606 delay_line3_1("delay_line_testing9", camac::Address("0:5:17:0"), step, delay);
camac::DelayLine_L0606 delay_line3_2("delay_line_testing10", camac::Address("0:5:17:1"), step, delay);
camac::DelayLine_L0606 delay_line3_3("delay_line_testing11", camac::Address("0:5:17:2"), step, delay);
camac::DelayLine_L0606 delay_line3_4("delay_line_testing12", camac::Address("0:5:17:3"), step, delay);

while(1)
   {
   for(int i=0 ; i<256*step ; i+=5)
      {
      std::cout<<"delay="<<i<<"\n";
      delay_line1_1.SetDelay(i);
      delay_line1_2.SetDelay(i);
      delay_line1_3.SetDelay(i);
      delay_line1_4.SetDelay(i);

      delay_line2_1.SetDelay(i);
      delay_line2_2.SetDelay(i);
      delay_line2_3.SetDelay(i);
      delay_line2_4.SetDelay(i);
      
      
      delay_line3_1.SetDelay(i);
      delay_line3_2.SetDelay(i);
      delay_line3_3.SetDelay(i);
      delay_line3_4.SetDelay(i);
      
      usleep(20000);
      }
   }



}
catch(camac::Crate::Error e)    {
	std::cerr << "\n***** camac crate error: " <<e.what() << "\n";
}
catch(camac::Module::Error e)    {
	std::cerr << "\n***** module crate error: " <<e.what() << "\n";
}
catch(std::logic_error e)    {
	std::cerr << "\n***** " <<e.what() << "\n";
}
catch(std::runtime_error e)    {
	std::cerr << "\n***** " << e.what() << "\n";
}
return 0;
}
