
#include <iostream>
#include "Depolarisator.h"

#include<getopt.h>
int main(int argc, char ** argv)    {
    int interface = -1;
	int crate = -1;
	int station = -1;
	int channel = -1;
    unsigned ifr,ffr,df,fd,t,s;

    int c;
    int digit_optind = 0;

	if(argc < 2) {
		cout << "Program test work of camac module Generator by frequency scaning procedure" << endl;
		cout << "Writen by Ivan B. Nikolaev, 39-41-78 19 OCT 2001" << endl;
		cout << "Usege: " << argv[0] << " interface/crate/station [option [parameter]]" << endl;
		cout << "Option is" << endl <<
			"--scan  if-ff/w/f/t : scan by parameter" 			<< endl <<
			"    where: if --- initial frequency" 				<< endl <<
			"           ff --- final frequency"					<< endl <<
			"           w  --- width of deviation"				<< endl <<
			"           f  --- deviation frequency"				<< endl <<
            		"           t  --- deviation time per one point"    << endl     ;

             exit(0);
	}
    	sscanf(argv[1],"%d/%d/%d",&interface,&crate,&station);
	try    {
                //camac::Crate * Crate = new camac::Crate(interface,crate);
				camac::Address g_adr("gen",interface,crate,station);
				camac::Address a_adr("gen",interface,crate,9);
				//camac::Address c_adr("gen",interface,crate,9);
				measurement::Depolarisator * dep = new measurement::Depolarisator(g_adr,a_adr);
	while (1)	{
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
			   {"scan",1,0,'s'},
             };

			 //c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			 c = getopt_long (argc, argv, "s:",long_options, &option_index);
			 if (c == -1)	break;

			 switch (c)	{
				 case 's':
					 sscanf(optarg,"%u-%u/%u/%u/%u",&ifr,&ffr,&df,&fd,&t);
					 cout << "# start frequency scaning " << flush;
                     			dep->SetInitialFrequency(ifr);
					dep->SetFinalFrequency(ffr);
					dep->SetFrequencyWidth(df);
					dep->SetDeviationFrequency(fd);
					dep->SetDeviationTime(t);
					
					 
					 dep->StartScan();
					 cout << " [OK]" << endl;

					 break;
				 case '?':
                 break;
               default:
                 printf ("?? getopt returned character code 0%o ??\n", c);
    		}
    }

    if (optind < argc-1)	{
             printf ("non-option ARGV-elements: ");
             while (optind < argc)
             printf ("%s ", argv[optind++]);
             printf ("\n");
	}
	// pthread_join(dep->thread,0);
    time_t begin = time(0);
	while(true) {
		sleep(t);
		//cerr << "Main (" << time(0) - begin << ") "<< dep->GetCurrentFrequency() << endl << flush;
	}

	}
         catch(camac::system_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}

	catch(camac::station_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::logic_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::runtime_error e)    {
		cerr << "\n***** " << e.what() << endl;
	}


	//cout << "  ,   " << endl << flush;

}

