#include "../camac/Diskr.h"

#include <iostream>
#include <cstdio>
#include <getopt.h>
#include <algorithm>

int main(int argc, char ** argv)    {
	int interface = -1;
	int crate = -1;
	int station = -1;
	int channel = -1;

	int c;
	int digit_optind = 0;

	if(argc < 2) {
		std::cout << "Program test work of camac module Timer (C2602) with 10ms minimal step\n";
		std::cout << "Writen by Ivan B. Nikolaev, 39-41-78 27 SEP 2001\n";
		std::cout << "Usege: " << argv[0] << "   interface:crate:station:channel [option [parameter]]\n";
		std::cout << "Option is\n"<<
			"--set : set treshold (mV)" <<"\n" <<
			"--get : get threshil (mV)\n";
		exit(0);
	}
	sscanf(argv[1],"%d:%d:%d:%d",&interface,&crate,&station,&channel);
	try    {
		//camac::Crate * Crate = new camac::Crate(interface,crate);
		camac::DiskrD0302 *Diskr;
		camac::DiskrD0302 *Diskr1;
		camac::DiskrD0302 *Diskr2;
		camac::DiskrD0302 *Diskr3;
		if(channel < 4) {
			camac::Address adr(interface,crate,station,channel);
			Diskr = new camac::DiskrD0302("d",adr);
		}
		else    {
			camac::Address adr(interface,crate,station,0);
			Diskr = new camac::DiskrD0302("d",adr);
			adr.channel=1;
			Diskr1 = new camac::DiskrD0302("d",adr);
			adr.channel=2;
			Diskr2 = new camac::DiskrD0302("d",adr);
			adr.channel=3;
			Diskr3 = new camac::DiskrD0302("d",adr);
		}

		while (1)	{
			int this_option_optind = optind ? optind : 1;
			int option_index = 0;
			static struct option long_options[] =
			{
				{"set",1,0,0},
				{"get",0,0,1},
			};

			//c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			c = getopt_long (argc, argv, "",long_options, &option_index);
			if (c == -1)	break;

			unsigned level=0;
			switch (c)	{
				case 0:
					sscanf(optarg,"%u",&level);
					std::cout << "# Set threashold \n";
					if(Diskr) Diskr->SetThreshold(level);
					if(Diskr1) Diskr1->SetThreshold(level);
					if(Diskr2) Diskr2->SetThreshold(level);
					if(Diskr3) Diskr3->SetThreshold(level);
					std::cout << " [OK]\n";
					break;
				case 1:
					std::cout << "# Get Threshold:  ";
					if(Diskr) std::cout << Diskr->GetThreshold() << "mV ";
					if(Diskr1) std::cout << Diskr1->GetThreshold() << "mV ";
					if(Diskr2) std::cout << Diskr2->GetThreshold() << "mV ";
					if(Diskr3) std::cout << Diskr3->GetThreshold() << "mV ";
					std::cout << " [OK]\n";
					break;
				case '?':
					break;

				default:
					printf ("?? getopt returned character code 0%o ??\n", c);
			}
		}

		if (optind < argc-1)
		{
			printf ("non-option ARGV-elements: ");
			while (optind < argc)
				printf ("%s ", argv[optind++]);
			printf ("\n");
		}

	}
	catch(camac::Module::Error e)    {
		std::cout << "\n***** " <<e.what() << "\n";
	}
}
