
#include <iostream>
#include "Frequencymeter.h"
#include<unistd.h>

#include<getopt.h>
int main(int argc, char ** argv)    {
	int interface_h = -1;
	int crate_h = -1;
	int station_h = -1;
	int channel_h = -1;
    	int interface_l = -1;
	int crate_l = -1;
	int station_l = -1;
	int channel_l = -1;
    	int c;
	int digit_optind = 0;
	double f;
	double sq;
	double aver;
    	unsigned time;
	bool stat=false;
	if(argc < 3) {
		cout << "Program test work of frequencymeter" << endl;
		cout << "Writen by Ivan B. Nikolaev, 39-41-78 21 JAN 2002" << endl;
		cout << "Usege: " << argv[0] << " interface/crate/station [option]" << endl;
		cout << "Option is" << endl <<
            	" --start time --- start frequency measurement with time" <<
		" --measure n:  measure n times" << endl;;
		//<<"           stop  --- stop frequency measurement"			<< endl;
             	exit(0);
	}
    	sscanf(argv[1],"%d/%d/%d",&interface_h,&crate_h,&station_h);
	sscanf(argv[2],"%d/%d/%d",&interface_l,&crate_l,&station_l);
	try	{
		camac::Address low("test high", interface_h, crate_h, station_h);
        	camac::Address high("test low",interface_l, crate_l, station_l);
		measurement::Frequencymeter *freq = new measurement::Frequencymeter(low,high);
		while (1)	{
             		int this_option_optind = optind ? optind : 1;
             		int option_index = 0;
             		static struct option long_options[] =
             		{
				 {"start",1,0,'s'},
				 {"stat",0,0,'v'},
				 {"stop",0,0,'e'},
				 {"measure",1,0,'m'},
				 
					 
				 {0,0,0,0}
             		};

			//c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			c = getopt_long (argc, argv, "s:e:m:",long_options, &option_index);
			if (c == -1)	break;
			switch (c)	{
				case 's':
                     			sscanf(optarg,"%u",&time);
					cout << "# start frequency measurement " << flush;
					freq->StartMeasurement();
                     			cout << " [OK]" << endl;
					while(true)    {
                         			sleep(time);
                         			cout << setprecision(10) << freq->GetMeasuredFrequency() << endl;
					}
					break;
                 		case 'e':
					cout << "# stop frequency measurement " << flush;
                     			freq->StopMeasurement();
					cout << " [OK]" << endl;
					break;
				case 'v':
					stat = true;
					break;
                 		case 'm':
                     			sscanf(optarg,"%u",&time);
					//cout << "# start frequency measurement " << flush;
					//freq->StartMeasurement();
                     			//cout << " [OK]" << endl;
					
					sq = 0;
					aver = 0;
					for(unsigned i =0 ; i< time; i++)   {
                         			sleep(1);
						f = freq->GetMeasuredFrequency();
						aver+=f;
						sq+=f*f;
						cout << setprecision(10) << f << endl;
					}
					aver /= time;
					sq /= time;
					if(stat)	{
						cout << "Average frequency: " << aver << endl;
						cout << "Sigma : " << sqrt(sq - aver*aver) << endl;
					}
					
					break;
				case '?':
					break;

               			default:
                 			printf ("?? getopt returned character code 0%o ??\n", c);
					break;
    			}
    		}
    		if (optind < argc-2)	{
             	printf ("non-option ARGV-elements: ");
             	while (optind < argc)
             	printf ("%s ", argv[optind++]);
             	printf ("\n");
	}
	}
        catch(camac::system_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}

	catch(camac::station_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::logic_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::runtime_error e)    {
		cerr << "\n***** " << e.what() << endl;
	}
}

