#include "../camac/Timer.h"

#include <iostream>
#include <cstdio>
#include <getopt.h>
#include <boost/program_options.hpp>

unsigned Log::debug_level = 1; //   
std::string Log::program_name = "test_timer: ";
bool Log::is_time = true;

using namespace std;

void options(int argc, char ** argv, boost::program_options::variables_map & vm) 
{
    namespace po=boost::program_options;
    po::options_description opt_desc("Allowed options");
    opt_desc.add_options()
	("help","Print this help")
	("a",po::value<string>(),"address interface/crate/station/channel")
	("start",po::value<double>(),"start timer")
	;
    po::store(po::parse_command_line(argc, argv, opt_desc), vm);
    po::notify(vm);    
    if (vm.count("help")) 
    {
	cout << "Test work of timer:" << endl;
	cout << opt_desc << "\n";
	exit(0);
    }
}


int main(int argc, char ** argv)    {
    boost::program_options::variables_map vm;
    try    {
	options(argc,argv,vm);
	std::string addr_str=vm["a"].as<string>();
	//string addr_str="TEST_TIMER:"+tmp_str;
	camac::Address adr(addr_str.c_str());
	camac::Timer Timer("timer",adr);
	if(vm.count("start"))	{
	    double t = vm["start"].as<double>();
	    Timer.Start(t);
	    Timer.Wait();
	    cout << "OK"<< endl;
	}
    }
    catch(camac::Crate::Error e)    {
	cerr << "ERROR: crate " <<e.what() << endl;
    }
    catch(camac::Module::Error e)    {
	cerr << "\n***** " <<e.what() << endl;
    }

    catch(std::runtime_error e)    {
	cerr << "\n***** " << e.what() << endl;
    }

    catch(std::logic_error e)	{
	cerr << "\n***** " << e.what() << endl;

    }
}
