//#include "camac/Vvi.h"

#include <iostream>
#include <cstdio>
//#include<getopt.h>
#include <algorithm>

#include "../camac/Vvi.h"

#include <boost/program_options.hpp>

unsigned Log::debug_level = 1; //   
std::string Log::program_name = "test_vvi: ";
bool Log::is_time = true;

using namespace std;
void options(int argc, char ** argv, boost::program_options::variables_map & vm) 
{
    namespace po=boost::program_options;
    po::options_description opt_desc("Allowed options");
    opt_desc.add_options()
	("help","Print this help")
	("a",po::value<string>(),"camac module address <interface:crate:station:channel>")
	("set",po::value<unsigned>(),"get voltage, V")
	("get","read voltage, V")
	("on","on")
	("off","off")
	("reset","reset")
	;
    po::store(po::parse_command_line(argc, argv, opt_desc), vm);
    po::notify(vm);    
    if (vm.count("help")) 
    {
	cout << "Usage: " << argv[0] << " interface/crate/station [option [parameter]]" << endl;
	cout << opt_desc << "\n";
	exit(0);
    }
}

int main(int argc, char ** argv)    {
    boost::program_options::variables_map vm;
    options(argc,argv,vm);
    std::string tmp_str=vm["a"].as<string>();
    //string addr_str="TEST_VVI:"+tmp_str;
    string addr_str=tmp_str;
    cout << "VVI address: " << tmp_str<< endl;
    try {
	camac::Address adr(addr_str.c_str());
	cout << "interface: "<< adr.interface << endl;
	cout << "crate: "<< adr.crate << endl;
	cout << "station: "<< adr.station << endl;
	cout << "channel: "<< adr.channel << endl;
	camac::Vvi_B0308 vvi("test_vvi",adr);
	if(vm.count("set")) {
	    unsigned v=vm["set"].as<unsigned>();
	    cout << "Setting voltage to: " << v << endl;
	    vvi.SetVolts(v);
	}
	if(vm.count("on"))  vvi.On();
	if(vm.count("off"))  vvi.Off();
	if(vm.count("reset"))  vvi.ResetOverload();
	unsigned v2 =vvi.GetVolts();
	string status  = vvi.GetStatus() ? "ON" : "OFF";
	cout << "Status: " << vvi.GetVolts() << " V ("<<status<<")" << endl;

    }

    catch(camac::Module::Error e)    {
	cerr << "\n***** " <<e.what() << endl;
    }
}
