#include <iostream>
#include <fstream>
#include <string>

#include "Stap.h"

namespace vepp4
{
	Stap::Stap(void)
	{
		Eset=-1;
		mode="????";
		Ie1=-1,Ie2=-1,Ip1=-1,Ip2=-1;
		status =0;
		sved = 0;
		const char * stap_file_name = "/home/vepp4/kadrs/stap.dat";
		std::ifstream stap(stap_file_name);
		if ( !stap) 
		{
			std::cerr << "V4Stap: Unable open stap file: " << stap_file_name << std::endl;
			return;
		}
		std::string line;
		int i=-1;
		while(stap>>line)
		{
			fMap[i]=line;
			i++;
			if(i>57) break; 
		}
		stap.close();
		try
		{
			mode = fMap[11];
			status = stoi(fMap[12]);
			Eset = stod(fMap[13])*1e-2;
			sved = stoi(fMap[15]);
			Ie1 = stod(fMap[45]);
			Ie2 = stod(fMap[46]);
			Ip1 = stod(fMap[47]);
			Ip2 = stod(fMap[48]);
			QX=stod(fMap[55])*1e-6;
			QZ=stod(fMap[56])*1e-6;
		}
		catch(std::logic_error e)
		{
			std::cout  << "Unable to read data from stap file: " << e.what() << std::endl;
			mode = "????";
			status = 0;
			Eset = 0;
			sved = 0;
			Ie1 = -1;
			Ie2 = -1;
			Ip1 = -1;
			Ip2 = -1;
			QX= -1;
			QZ= -1;
		}
		std::ifstream rf("/home/vepp4/kadrs/RF.dat");
		if (!rf)
		{ 
			std::cerr << "ERROR: unable to open file /home/vepp4/kadrs/RF.dat\n";
			RF=818924*222;
		}
		rf >> RF;
	}
}
